// Autogenerated from Pigeon (v17.0.0), do not edit directly.
// See also: https://pub.dev/packages/pigeon

package com.aidlab.aidlab_sdk

import android.util.Log
import io.flutter.plugin.common.BasicMessageChannel
import io.flutter.plugin.common.BinaryMessenger
import io.flutter.plugin.common.MessageCodec
import io.flutter.plugin.common.StandardMessageCodec
import java.io.ByteArrayOutputStream
import java.nio.ByteBuffer

private fun wrapResult(result: Any?): List<Any?> {
  return listOf(result)
}

private fun wrapError(exception: Throwable): List<Any?> {
  if (exception is FlutterError) {
    return listOf(
      exception.code,
      exception.message,
      exception.details
    )
  } else {
    return listOf(
      exception.javaClass.simpleName,
      exception.toString(),
      "Cause: " + exception.cause + ", Stacktrace: " + Log.getStackTraceString(exception)
    )
  }
}

private fun createConnectionError(channelName: String): FlutterError {
  return FlutterError("channel-error",  "Unable to establish connection on channel: '$channelName'.", "")}

/**
 * Error class for passing custom error details to Flutter via a thrown PlatformException.
 * @property code The error code.
 * @property message The error message.
 * @property details The error details. Must be a datatype supported by the api codec.
 */
class FlutterError (
  val code: String,
  override val message: String? = null,
  val details: Any? = null
) : Throwable()

/** Generated class from Pigeon that represents data sent in messages. */
data class ScanModeRequest (
  val mode: Long? = null

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): ScanModeRequest {
      val mode = list[0].let { if (it is Int) it.toLong() else it as Long? }
      return ScanModeRequest(mode)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      mode,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class ConnectRequest (
  val address: String? = null,
  val signals: IntArray? = null

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): ConnectRequest {
      val address = list[0] as String?
      val signals = list[1] as IntArray?
      return ConnectRequest(address, signals)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      address,
      signals,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class AidlabDetectedEvent (
  val address: String? = null,
  val rssi: Long? = null

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): AidlabDetectedEvent {
      val address = list[0] as String?
      val rssi = list[1].let { if (it is Int) it.toLong() else it as Long? }
      return AidlabDetectedEvent(address, rssi)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      address,
      rssi,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class ScanFailedEvent (
  val errorCode: Long? = null

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): ScanFailedEvent {
      val errorCode = list[0].let { if (it is Int) it.toLong() else it as Long? }
      return ScanFailedEvent(errorCode)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      errorCode,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class LogEvent (
  val msg: String? = null

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): LogEvent {
      val msg = list[0] as String?
      return LogEvent(msg)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      msg,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class ConnectEvent (
  val firmwareRevision: String,
  val hardwareRevision: String,
  val serialNumber: String,
  val address: String

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): ConnectEvent {
      val firmwareRevision = list[0] as String
      val hardwareRevision = list[1] as String
      val serialNumber = list[2] as String
      val address = list[3] as String
      return ConnectEvent(firmwareRevision, hardwareRevision, serialNumber, address)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      firmwareRevision,
      hardwareRevision,
      serialNumber,
      address,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class EcgEvent (
  val timestamp: Long,
  val values: DoubleArray

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): EcgEvent {
      val timestamp = list[0].let { if (it is Int) it.toLong() else it as Long }
      val values = list[1] as DoubleArray
      return EcgEvent(timestamp, values)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      timestamp,
      values,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class RespirationEvent (
  val timestamp: Long,
  val values: DoubleArray

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): RespirationEvent {
      val timestamp = list[0].let { if (it is Int) it.toLong() else it as Long }
      val values = list[1] as DoubleArray
      return RespirationEvent(timestamp, values)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      timestamp,
      values,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class RespirationRateEvent (
  val timestamp: Long,
  val value: Long

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): RespirationRateEvent {
      val timestamp = list[0].let { if (it is Int) it.toLong() else it as Long }
      val value = list[1].let { if (it is Int) it.toLong() else it as Long }
      return RespirationRateEvent(timestamp, value)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      timestamp,
      value,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class BatteryLevelEvent (
  val stateOfCharge: Long

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): BatteryLevelEvent {
      val stateOfCharge = list[0].let { if (it is Int) it.toLong() else it as Long }
      return BatteryLevelEvent(stateOfCharge)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      stateOfCharge,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class VectorEvent (
  val timestamp: Long,
  val x: Double,
  val y: Double,
  val z: Double

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): VectorEvent {
      val timestamp = list[0].let { if (it is Int) it.toLong() else it as Long }
      val x = list[1] as Double
      val y = list[2] as Double
      val z = list[3] as Double
      return VectorEvent(timestamp, x, y, z)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      timestamp,
      x,
      y,
      z,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class QuaternionEvent (
  val timestamp: Long,
  val qw: Double,
  val qx: Double,
  val qy: Double,
  val qz: Double

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): QuaternionEvent {
      val timestamp = list[0].let { if (it is Int) it.toLong() else it as Long }
      val qw = list[1] as Double
      val qx = list[2] as Double
      val qy = list[3] as Double
      val qz = list[4] as Double
      return QuaternionEvent(timestamp, qw, qx, qy, qz)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      timestamp,
      qw,
      qx,
      qy,
      qz,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class OrientationEvent (
  val timestamp: Long,
  val roll: Double,
  val pitch: Double,
  val yaw: Double

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): OrientationEvent {
      val timestamp = list[0].let { if (it is Int) it.toLong() else it as Long }
      val roll = list[1] as Double
      val pitch = list[2] as Double
      val yaw = list[3] as Double
      return OrientationEvent(timestamp, roll, pitch, yaw)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      timestamp,
      roll,
      pitch,
      yaw,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class BodyPositionEvent (
  val timestamp: Long,
  val bodyPosition: Long

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): BodyPositionEvent {
      val timestamp = list[0].let { if (it is Int) it.toLong() else it as Long }
      val bodyPosition = list[1].let { if (it is Int) it.toLong() else it as Long }
      return BodyPositionEvent(timestamp, bodyPosition)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      timestamp,
      bodyPosition,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class ActivityEvent (
  val timestamp: Long,
  val activityType: Long

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): ActivityEvent {
      val timestamp = list[0].let { if (it is Int) it.toLong() else it as Long }
      val activityType = list[1].let { if (it is Int) it.toLong() else it as Long }
      return ActivityEvent(timestamp, activityType)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      timestamp,
      activityType,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class StepsEvent (
  val timestamp: Long,
  val value: Long

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): StepsEvent {
      val timestamp = list[0].let { if (it is Int) it.toLong() else it as Long }
      val value = list[1].let { if (it is Int) it.toLong() else it as Long }
      return StepsEvent(timestamp, value)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      timestamp,
      value,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class HeartRateEvent (
  val timestamp: Long,
  val heartRate: Long

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): HeartRateEvent {
      val timestamp = list[0].let { if (it is Int) it.toLong() else it as Long }
      val heartRate = list[1].let { if (it is Int) it.toLong() else it as Long }
      return HeartRateEvent(timestamp, heartRate)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      timestamp,
      heartRate,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class RrEvent (
  val timestamp: Long,
  val rr: Long

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): RrEvent {
      val timestamp = list[0].let { if (it is Int) it.toLong() else it as Long }
      val rr = list[1].let { if (it is Int) it.toLong() else it as Long }
      return RrEvent(timestamp, rr)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      timestamp,
      rr,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class WearStateEvent (
  val wearState: Long

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): WearStateEvent {
      val wearState = list[0].let { if (it is Int) it.toLong() else it as Long }
      return WearStateEvent(wearState)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      wearState,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class SkinTemperatureEvent (
  val timestamp: Long,
  val value: Double

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): SkinTemperatureEvent {
      val timestamp = list[0].let { if (it is Int) it.toLong() else it as Long }
      val value = list[1] as Double
      return SkinTemperatureEvent(timestamp, value)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      timestamp,
      value,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class ExerciseEvent (
  val exercise: Long? = null

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): ExerciseEvent {
      val exercise = list[0].let { if (it is Int) it.toLong() else it as Long? }
      return ExerciseEvent(exercise)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      exercise,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class SoundVolumeEvent (
  val timestamp: Long,
  val soundVolume: Long

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): SoundVolumeEvent {
      val timestamp = list[0].let { if (it is Int) it.toLong() else it as Long }
      val soundVolume = list[1].let { if (it is Int) it.toLong() else it as Long }
      return SoundVolumeEvent(timestamp, soundVolume)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      timestamp,
      soundVolume,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class ErrorEvent (
  val error: String

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): ErrorEvent {
      val error = list[0] as String
      return ErrorEvent(error)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      error,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class MessageEvent (
  val process: String,
  val message: String

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): MessageEvent {
      val process = list[0] as String
      val message = list[1] as String
      return MessageEvent(process, message)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      process,
      message,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class UserEvent (
  val timestamp: Long

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): UserEvent {
      val timestamp = list[0].let { if (it is Int) it.toLong() else it as Long }
      return UserEvent(timestamp)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      timestamp,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class SoundFeaturesEvent (
  val values: DoubleArray

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): SoundFeaturesEvent {
      val values = list[0] as DoubleArray
      return SoundFeaturesEvent(values)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      values,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class DisconnectEvent (
  val disconnectReason: Long

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): DisconnectEvent {
      val disconnectReason = list[0].let { if (it is Int) it.toLong() else it as Long }
      return DisconnectEvent(disconnectReason)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      disconnectReason,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class SignalQualityEvent (
  val timestamp: Long,
  val value: Long

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): SignalQualityEvent {
      val timestamp = list[0].let { if (it is Int) it.toLong() else it as Long }
      val value = list[1].let { if (it is Int) it.toLong() else it as Long }
      return SignalQualityEvent(timestamp, value)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      timestamp,
      value,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class FirmwareInformationEvent (
  val updateAvailable: Boolean? = null,
  val updatableVersion: String? = null

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): FirmwareInformationEvent {
      val updateAvailable = list[0] as Boolean?
      val updatableVersion = list[1] as String?
      return FirmwareInformationEvent(updateAvailable, updatableVersion)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      updateAvailable,
      updatableVersion,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class PressureEvent (
  val timestamp: Long? = null,
  val values: IntArray? = null

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): PressureEvent {
      val timestamp = list[0].let { if (it is Int) it.toLong() else it as Long? }
      val values = list[1] as IntArray?
      return PressureEvent(timestamp, values)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      timestamp,
      values,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class PressureWearStateEvent (
  val wearState: Long? = null

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): PressureWearStateEvent {
      val wearState = list[0].let { if (it is Int) it.toLong() else it as Long? }
      return PressureWearStateEvent(wearState)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      wearState,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class UpdateProgress (
  val progress: Long? = null

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): UpdateProgress {
      val progress = list[0].let { if (it is Int) it.toLong() else it as Long? }
      return UpdateProgress(progress)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      progress,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class UpdateEvent (
  val error: Long? = null

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): UpdateEvent {
      val error = list[0].let { if (it is Int) it.toLong() else it as Long? }
      return UpdateEvent(error)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      error,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class SendRequest (
  val command: String

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): SendRequest {
      val command = list[0] as String
      return SendRequest(command)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      command,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class EcgFiltrationRequest (
  val method: Long

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): EcgFiltrationRequest {
      val method = list[0].let { if (it is Int) it.toLong() else it as Long }
      return EcgFiltrationRequest(method)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      method,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class FirmwareInfoRequest (
  val url: String

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): FirmwareInfoRequest {
      val url = list[0] as String
      return FirmwareInfoRequest(url)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      url,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class FirmwareUpdateRequest (
  val url: String,
  val updatableVersion: String

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): FirmwareUpdateRequest {
      val url = list[0] as String
      val updatableVersion = list[1] as String
      return FirmwareUpdateRequest(url, updatableVersion)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      url,
      updatableVersion,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class SyncStateEvent (
  val state: Long

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): SyncStateEvent {
      val state = list[0].let { if (it is Int) it.toLong() else it as Long }
      return SyncStateEvent(state)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      state,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class UnsynchronizedSizeEvent (
  val unsynchronizedSize: Long,
  val syncBytesPerSecond: Double

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): UnsynchronizedSizeEvent {
      val unsynchronizedSize = list[0].let { if (it is Int) it.toLong() else it as Long }
      val syncBytesPerSecond = list[1] as Double
      return UnsynchronizedSizeEvent(unsynchronizedSize, syncBytesPerSecond)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      unsynchronizedSize,
      syncBytesPerSecond,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class EmptyEvent (
  val nothing: Long

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): EmptyEvent {
      val nothing = list[0].let { if (it is Int) it.toLong() else it as Long }
      return EmptyEvent(nothing)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      nothing,
    )
  }
}
@Suppress("UNCHECKED_CAST")
private object PlatformAidlabSdkCodec : StandardMessageCodec() {
  override fun readValueOfType(type: Byte, buffer: ByteBuffer): Any? {
    return when (type) {
      128.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          ConnectRequest.fromList(it)
        }
      }
      129.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          ScanModeRequest.fromList(it)
        }
      }
      else -> super.readValueOfType(type, buffer)
    }
  }
  override fun writeValue(stream: ByteArrayOutputStream, value: Any?)   {
    when (value) {
      is ConnectRequest -> {
        stream.write(128)
        writeValue(stream, value.toList())
      }
      is ScanModeRequest -> {
        stream.write(129)
        writeValue(stream, value.toList())
      }
      else -> super.writeValue(stream, value)
    }
  }
}

/** Generated interface from Pigeon that represents a handler of messages from Flutter. */
interface PlatformAidlabSdk {
  fun initSdk()
  fun scanForDevices(scanMode: ScanModeRequest)
  fun stopDeviceScan()
  fun connect(request: ConnectRequest)

  companion object {
    /** The codec used by PlatformAidlabSdk. */
    val codec: MessageCodec<Any?> by lazy {
      PlatformAidlabSdkCodec
    }
    /** Sets up an instance of `PlatformAidlabSdk` to handle messages through the `binaryMessenger`. */
    @Suppress("UNCHECKED_CAST")
    fun setUp(binaryMessenger: BinaryMessenger, api: PlatformAidlabSdk?) {
      run {
        val channel = BasicMessageChannel<Any?>(binaryMessenger, "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdk.initSdk", codec)
        if (api != null) {
          channel.setMessageHandler { _, reply ->
            var wrapped: List<Any?>
            try {
              api.initSdk()
              wrapped = listOf<Any?>(null)
            } catch (exception: Throwable) {
              wrapped = wrapError(exception)
            }
            reply.reply(wrapped)
          }
        } else {
          channel.setMessageHandler(null)
        }
      }
      run {
        val channel = BasicMessageChannel<Any?>(binaryMessenger, "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdk.scanForDevices", codec)
        if (api != null) {
          channel.setMessageHandler { message, reply ->
            val args = message as List<Any?>
            val scanModeArg = args[0] as ScanModeRequest
            var wrapped: List<Any?>
            try {
              api.scanForDevices(scanModeArg)
              wrapped = listOf<Any?>(null)
            } catch (exception: Throwable) {
              wrapped = wrapError(exception)
            }
            reply.reply(wrapped)
          }
        } else {
          channel.setMessageHandler(null)
        }
      }
      run {
        val channel = BasicMessageChannel<Any?>(binaryMessenger, "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdk.stopDeviceScan", codec)
        if (api != null) {
          channel.setMessageHandler { _, reply ->
            var wrapped: List<Any?>
            try {
              api.stopDeviceScan()
              wrapped = listOf<Any?>(null)
            } catch (exception: Throwable) {
              wrapped = wrapError(exception)
            }
            reply.reply(wrapped)
          }
        } else {
          channel.setMessageHandler(null)
        }
      }
      run {
        val channel = BasicMessageChannel<Any?>(binaryMessenger, "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdk.connect", codec)
        if (api != null) {
          channel.setMessageHandler { message, reply ->
            val args = message as List<Any?>
            val requestArg = args[0] as ConnectRequest
            var wrapped: List<Any?>
            try {
              api.connect(requestArg)
              wrapped = listOf<Any?>(null)
            } catch (exception: Throwable) {
              wrapped = wrapError(exception)
            }
            reply.reply(wrapped)
          }
        } else {
          channel.setMessageHandler(null)
        }
      }
    }
  }
}
@Suppress("UNCHECKED_CAST")
private object PlatformAidlabSdkDelegateCodec : StandardMessageCodec() {
  override fun readValueOfType(type: Byte, buffer: ByteBuffer): Any? {
    return when (type) {
      128.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          AidlabDetectedEvent.fromList(it)
        }
      }
      129.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          EmptyEvent.fromList(it)
        }
      }
      130.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          ScanFailedEvent.fromList(it)
        }
      }
      else -> super.readValueOfType(type, buffer)
    }
  }
  override fun writeValue(stream: ByteArrayOutputStream, value: Any?)   {
    when (value) {
      is AidlabDetectedEvent -> {
        stream.write(128)
        writeValue(stream, value.toList())
      }
      is EmptyEvent -> {
        stream.write(129)
        writeValue(stream, value.toList())
      }
      is ScanFailedEvent -> {
        stream.write(130)
        writeValue(stream, value.toList())
      }
      else -> super.writeValue(stream, value)
    }
  }
}

/** Generated class from Pigeon that represents Flutter messages that can be called from Kotlin. */
@Suppress("UNCHECKED_CAST")
class PlatformAidlabSdkDelegate(private val binaryMessenger: BinaryMessenger) {
  companion object {
    /** The codec used by PlatformAidlabSdkDelegate. */
    val codec: MessageCodec<Any?> by lazy {
      PlatformAidlabSdkDelegateCodec
    }
  }
  fun onBluetoothStarted(voidEventArg: EmptyEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onBluetoothStarted"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(voidEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun onDeviceScanStarted(voidEventArg: EmptyEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onDeviceScanStarted"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(voidEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun onDeviceScanStopped(voidEventArg: EmptyEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onDeviceScanStopped"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(voidEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun onScanFailed(eventArg: ScanFailedEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onScanFailed"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(eventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun onAidlabDetected(eventArg: AidlabDetectedEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onAidlabDetected"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(eventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
}
@Suppress("UNCHECKED_CAST")
private object PlatformAidlabLoggerCodec : StandardMessageCodec() {
  override fun readValueOfType(type: Byte, buffer: ByteBuffer): Any? {
    return when (type) {
      128.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          LogEvent.fromList(it)
        }
      }
      else -> super.readValueOfType(type, buffer)
    }
  }
  override fun writeValue(stream: ByteArrayOutputStream, value: Any?)   {
    when (value) {
      is LogEvent -> {
        stream.write(128)
        writeValue(stream, value.toList())
      }
      else -> super.writeValue(stream, value)
    }
  }
}

/** Generated class from Pigeon that represents Flutter messages that can be called from Kotlin. */
@Suppress("UNCHECKED_CAST")
class PlatformAidlabLogger(private val binaryMessenger: BinaryMessenger) {
  companion object {
    /** The codec used by PlatformAidlabLogger. */
    val codec: MessageCodec<Any?> by lazy {
      PlatformAidlabLoggerCodec
    }
  }
  fun onLog(eventArg: LogEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabLogger.onLog"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(eventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun onWarning(eventArg: LogEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabLogger.onWarning"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(eventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun onError(eventArg: LogEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabLogger.onError"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(eventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
}
@Suppress("UNCHECKED_CAST")
private object PlatformAidlabDelegateCodec : StandardMessageCodec() {
  override fun readValueOfType(type: Byte, buffer: ByteBuffer): Any? {
    return when (type) {
      128.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          ActivityEvent.fromList(it)
        }
      }
      129.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          BatteryLevelEvent.fromList(it)
        }
      }
      130.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          BodyPositionEvent.fromList(it)
        }
      }
      131.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          ConnectEvent.fromList(it)
        }
      }
      132.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          DisconnectEvent.fromList(it)
        }
      }
      133.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          EcgEvent.fromList(it)
        }
      }
      134.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          EmptyEvent.fromList(it)
        }
      }
      135.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          ErrorEvent.fromList(it)
        }
      }
      136.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          ExerciseEvent.fromList(it)
        }
      }
      137.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          HeartRateEvent.fromList(it)
        }
      }
      138.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          MessageEvent.fromList(it)
        }
      }
      139.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          OrientationEvent.fromList(it)
        }
      }
      140.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          QuaternionEvent.fromList(it)
        }
      }
      141.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          RespirationEvent.fromList(it)
        }
      }
      142.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          RespirationRateEvent.fromList(it)
        }
      }
      143.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          RrEvent.fromList(it)
        }
      }
      144.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          SignalQualityEvent.fromList(it)
        }
      }
      145.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          SkinTemperatureEvent.fromList(it)
        }
      }
      146.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          SoundFeaturesEvent.fromList(it)
        }
      }
      147.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          SoundVolumeEvent.fromList(it)
        }
      }
      148.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          StepsEvent.fromList(it)
        }
      }
      149.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          UserEvent.fromList(it)
        }
      }
      150.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          VectorEvent.fromList(it)
        }
      }
      151.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          WearStateEvent.fromList(it)
        }
      }
      else -> super.readValueOfType(type, buffer)
    }
  }
  override fun writeValue(stream: ByteArrayOutputStream, value: Any?)   {
    when (value) {
      is ActivityEvent -> {
        stream.write(128)
        writeValue(stream, value.toList())
      }
      is BatteryLevelEvent -> {
        stream.write(129)
        writeValue(stream, value.toList())
      }
      is BodyPositionEvent -> {
        stream.write(130)
        writeValue(stream, value.toList())
      }
      is ConnectEvent -> {
        stream.write(131)
        writeValue(stream, value.toList())
      }
      is DisconnectEvent -> {
        stream.write(132)
        writeValue(stream, value.toList())
      }
      is EcgEvent -> {
        stream.write(133)
        writeValue(stream, value.toList())
      }
      is EmptyEvent -> {
        stream.write(134)
        writeValue(stream, value.toList())
      }
      is ErrorEvent -> {
        stream.write(135)
        writeValue(stream, value.toList())
      }
      is ExerciseEvent -> {
        stream.write(136)
        writeValue(stream, value.toList())
      }
      is HeartRateEvent -> {
        stream.write(137)
        writeValue(stream, value.toList())
      }
      is MessageEvent -> {
        stream.write(138)
        writeValue(stream, value.toList())
      }
      is OrientationEvent -> {
        stream.write(139)
        writeValue(stream, value.toList())
      }
      is QuaternionEvent -> {
        stream.write(140)
        writeValue(stream, value.toList())
      }
      is RespirationEvent -> {
        stream.write(141)
        writeValue(stream, value.toList())
      }
      is RespirationRateEvent -> {
        stream.write(142)
        writeValue(stream, value.toList())
      }
      is RrEvent -> {
        stream.write(143)
        writeValue(stream, value.toList())
      }
      is SignalQualityEvent -> {
        stream.write(144)
        writeValue(stream, value.toList())
      }
      is SkinTemperatureEvent -> {
        stream.write(145)
        writeValue(stream, value.toList())
      }
      is SoundFeaturesEvent -> {
        stream.write(146)
        writeValue(stream, value.toList())
      }
      is SoundVolumeEvent -> {
        stream.write(147)
        writeValue(stream, value.toList())
      }
      is StepsEvent -> {
        stream.write(148)
        writeValue(stream, value.toList())
      }
      is UserEvent -> {
        stream.write(149)
        writeValue(stream, value.toList())
      }
      is VectorEvent -> {
        stream.write(150)
        writeValue(stream, value.toList())
      }
      is WearStateEvent -> {
        stream.write(151)
        writeValue(stream, value.toList())
      }
      else -> super.writeValue(stream, value)
    }
  }
}

/** Generated class from Pigeon that represents Flutter messages that can be called from Kotlin. */
@Suppress("UNCHECKED_CAST")
class PlatformAidlabDelegate(private val binaryMessenger: BinaryMessenger) {
  companion object {
    /** The codec used by PlatformAidlabDelegate. */
    val codec: MessageCodec<Any?> by lazy {
      PlatformAidlabDelegateCodec
    }
  }
  fun didConnect(connectEventArg: ConnectEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didConnect"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(connectEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didDisconnect(voidEventArg: DisconnectEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didDisconnect"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(voidEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveEcg(ecgEventArg: EcgEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveEcg"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(ecgEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveRespiration(respirationEventArg: RespirationEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveRespiration"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(respirationEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveRespirationRate(respirationRateEventArg: RespirationRateEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveRespirationRate"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(respirationRateEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveBatteryLevel(batteryLevelEventArg: BatteryLevelEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveBatteryLevel"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(batteryLevelEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveSkinTemperature(skinTemperatureEventArg: SkinTemperatureEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSkinTemperature"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(skinTemperatureEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveAccelerometer(vectorEventArg: VectorEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveAccelerometer"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(vectorEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveGyroscope(vectorEventArg: VectorEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveGyroscope"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(vectorEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveMagnetometer(vectorEventArg: VectorEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveMagnetometer"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(vectorEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveQuaternion(quaternionEventArg: QuaternionEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveQuaternion"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(quaternionEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveOrientation(orientationEventArg: OrientationEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveOrientation"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(orientationEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveBodyPosition(bodyPositionEventArg: BodyPositionEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveBodyPosition"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(bodyPositionEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveActivity(activityEventArg: ActivityEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveActivity"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(activityEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveSteps(stepsEventArg: StepsEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSteps"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(stepsEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveHeartRate(heartRateEventArg: HeartRateEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveHeartRate"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(heartRateEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveRr(rrEventArg: RrEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveRr"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(rrEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun wearStateDidChange(wearStateEventArg: WearStateEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.wearStateDidChange"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(wearStateEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didDetectExercise(exerciseEventArg: ExerciseEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didDetectExercise"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(exerciseEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveSoundVolume(soundVolumeEventArg: SoundVolumeEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSoundVolume"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(soundVolumeEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveCommand(voidEventArg: EmptyEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveCommand"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(voidEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveError(errorEventArg: ErrorEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveError"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(errorEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveMessage(messageEventArg: MessageEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveMessage"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(messageEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didDetectUserEvent(userEventArg: UserEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didDetectUserEvent"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(userEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveSoundFeatures(soundFeaturesEventArg: SoundFeaturesEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSoundFeatures"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(soundFeaturesEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveSignalQuality(signalQualityEventArg: SignalQualityEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSignalQuality"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(signalQualityEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
}
@Suppress("UNCHECKED_CAST")
private object PlatformAidlabInternalDelegateCodec : StandardMessageCodec() {
  override fun readValueOfType(type: Byte, buffer: ByteBuffer): Any? {
    return when (type) {
      128.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          FirmwareInformationEvent.fromList(it)
        }
      }
      129.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          PressureEvent.fromList(it)
        }
      }
      130.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          PressureWearStateEvent.fromList(it)
        }
      }
      else -> super.readValueOfType(type, buffer)
    }
  }
  override fun writeValue(stream: ByteArrayOutputStream, value: Any?)   {
    when (value) {
      is FirmwareInformationEvent -> {
        stream.write(128)
        writeValue(stream, value.toList())
      }
      is PressureEvent -> {
        stream.write(129)
        writeValue(stream, value.toList())
      }
      is PressureWearStateEvent -> {
        stream.write(130)
        writeValue(stream, value.toList())
      }
      else -> super.writeValue(stream, value)
    }
  }
}

/** Generated class from Pigeon that represents Flutter messages that can be called from Kotlin. */
@Suppress("UNCHECKED_CAST")
class PlatformAidlabInternalDelegate(private val binaryMessenger: BinaryMessenger) {
  companion object {
    /** The codec used by PlatformAidlabInternalDelegate. */
    val codec: MessageCodec<Any?> by lazy {
      PlatformAidlabInternalDelegateCodec
    }
  }
  fun didReceiveFirmwareInformation(firmwareInformationEventArg: FirmwareInformationEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabInternalDelegate.didReceiveFirmwareInformation"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(firmwareInformationEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePressure(pressureEventArg: PressureEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabInternalDelegate.didReceivePressure"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(pressureEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun pressureWearStateDidChange(wearStateEventArg: PressureWearStateEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabInternalDelegate.pressureWearStateDidChange"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(wearStateEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
}
@Suppress("UNCHECKED_CAST")
private object PlatformAidlabUpdateDelegateCodec : StandardMessageCodec() {
  override fun readValueOfType(type: Byte, buffer: ByteBuffer): Any? {
    return when (type) {
      128.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          EmptyEvent.fromList(it)
        }
      }
      129.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          UpdateEvent.fromList(it)
        }
      }
      130.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          UpdateProgress.fromList(it)
        }
      }
      else -> super.readValueOfType(type, buffer)
    }
  }
  override fun writeValue(stream: ByteArrayOutputStream, value: Any?)   {
    when (value) {
      is EmptyEvent -> {
        stream.write(128)
        writeValue(stream, value.toList())
      }
      is UpdateEvent -> {
        stream.write(129)
        writeValue(stream, value.toList())
      }
      is UpdateProgress -> {
        stream.write(130)
        writeValue(stream, value.toList())
      }
      else -> super.writeValue(stream, value)
    }
  }
}

/** Generated class from Pigeon that represents Flutter messages that can be called from Kotlin. */
@Suppress("UNCHECKED_CAST")
class PlatformAidlabUpdateDelegate(private val binaryMessenger: BinaryMessenger) {
  companion object {
    /** The codec used by PlatformAidlabUpdateDelegate. */
    val codec: MessageCodec<Any?> by lazy {
      PlatformAidlabUpdateDelegateCodec
    }
  }
  fun didFinishUpdate(nothingArg: EmptyEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabUpdateDelegate.didFinishUpdate"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(nothingArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveUpdateError(eventArg: UpdateEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabUpdateDelegate.didReceiveUpdateError"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(eventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveUpdateProgress(progressArg: UpdateProgress, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabUpdateDelegate.didReceiveUpdateProgress"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(progressArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
}
@Suppress("UNCHECKED_CAST")
private object PlatformAidlabCodec : StandardMessageCodec() {
  override fun readValueOfType(type: Byte, buffer: ByteBuffer): Any? {
    return when (type) {
      128.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          EcgFiltrationRequest.fromList(it)
        }
      }
      129.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          FirmwareInfoRequest.fromList(it)
        }
      }
      130.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          FirmwareUpdateRequest.fromList(it)
        }
      }
      131.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          SendRequest.fromList(it)
        }
      }
      else -> super.readValueOfType(type, buffer)
    }
  }
  override fun writeValue(stream: ByteArrayOutputStream, value: Any?)   {
    when (value) {
      is EcgFiltrationRequest -> {
        stream.write(128)
        writeValue(stream, value.toList())
      }
      is FirmwareInfoRequest -> {
        stream.write(129)
        writeValue(stream, value.toList())
      }
      is FirmwareUpdateRequest -> {
        stream.write(130)
        writeValue(stream, value.toList())
      }
      is SendRequest -> {
        stream.write(131)
        writeValue(stream, value.toList())
      }
      else -> super.writeValue(stream, value)
    }
  }
}

/** Generated interface from Pigeon that represents a handler of messages from Flutter. */
interface PlatformAidlab {
  fun disconnect()
  fun send(sendRequest: SendRequest)
  fun setECGFiltrationMethod(ecgFiltrationRequest: EcgFiltrationRequest)
  fun startSynchronization()
  fun stopSynchronization()
  fun requestForFirmwareInfo(firmwareInfoRequest: FirmwareInfoRequest)
  fun startFirmwareUpdate(firmwareUpdateRequest: FirmwareUpdateRequest)

  companion object {
    /** The codec used by PlatformAidlab. */
    val codec: MessageCodec<Any?> by lazy {
      PlatformAidlabCodec
    }
    /** Sets up an instance of `PlatformAidlab` to handle messages through the `binaryMessenger`. */
    @Suppress("UNCHECKED_CAST")
    fun setUp(binaryMessenger: BinaryMessenger, api: PlatformAidlab?) {
      run {
        val channel = BasicMessageChannel<Any?>(binaryMessenger, "dev.flutter.pigeon.aidlab_sdk.PlatformAidlab.disconnect", codec)
        if (api != null) {
          channel.setMessageHandler { _, reply ->
            var wrapped: List<Any?>
            try {
              api.disconnect()
              wrapped = listOf<Any?>(null)
            } catch (exception: Throwable) {
              wrapped = wrapError(exception)
            }
            reply.reply(wrapped)
          }
        } else {
          channel.setMessageHandler(null)
        }
      }
      run {
        val channel = BasicMessageChannel<Any?>(binaryMessenger, "dev.flutter.pigeon.aidlab_sdk.PlatformAidlab.send", codec)
        if (api != null) {
          channel.setMessageHandler { message, reply ->
            val args = message as List<Any?>
            val sendRequestArg = args[0] as SendRequest
            var wrapped: List<Any?>
            try {
              api.send(sendRequestArg)
              wrapped = listOf<Any?>(null)
            } catch (exception: Throwable) {
              wrapped = wrapError(exception)
            }
            reply.reply(wrapped)
          }
        } else {
          channel.setMessageHandler(null)
        }
      }
      run {
        val channel = BasicMessageChannel<Any?>(binaryMessenger, "dev.flutter.pigeon.aidlab_sdk.PlatformAidlab.setECGFiltrationMethod", codec)
        if (api != null) {
          channel.setMessageHandler { message, reply ->
            val args = message as List<Any?>
            val ecgFiltrationRequestArg = args[0] as EcgFiltrationRequest
            var wrapped: List<Any?>
            try {
              api.setECGFiltrationMethod(ecgFiltrationRequestArg)
              wrapped = listOf<Any?>(null)
            } catch (exception: Throwable) {
              wrapped = wrapError(exception)
            }
            reply.reply(wrapped)
          }
        } else {
          channel.setMessageHandler(null)
        }
      }
      run {
        val channel = BasicMessageChannel<Any?>(binaryMessenger, "dev.flutter.pigeon.aidlab_sdk.PlatformAidlab.startSynchronization", codec)
        if (api != null) {
          channel.setMessageHandler { _, reply ->
            var wrapped: List<Any?>
            try {
              api.startSynchronization()
              wrapped = listOf<Any?>(null)
            } catch (exception: Throwable) {
              wrapped = wrapError(exception)
            }
            reply.reply(wrapped)
          }
        } else {
          channel.setMessageHandler(null)
        }
      }
      run {
        val channel = BasicMessageChannel<Any?>(binaryMessenger, "dev.flutter.pigeon.aidlab_sdk.PlatformAidlab.stopSynchronization", codec)
        if (api != null) {
          channel.setMessageHandler { _, reply ->
            var wrapped: List<Any?>
            try {
              api.stopSynchronization()
              wrapped = listOf<Any?>(null)
            } catch (exception: Throwable) {
              wrapped = wrapError(exception)
            }
            reply.reply(wrapped)
          }
        } else {
          channel.setMessageHandler(null)
        }
      }
      run {
        val channel = BasicMessageChannel<Any?>(binaryMessenger, "dev.flutter.pigeon.aidlab_sdk.PlatformAidlab.requestForFirmwareInfo", codec)
        if (api != null) {
          channel.setMessageHandler { message, reply ->
            val args = message as List<Any?>
            val firmwareInfoRequestArg = args[0] as FirmwareInfoRequest
            var wrapped: List<Any?>
            try {
              api.requestForFirmwareInfo(firmwareInfoRequestArg)
              wrapped = listOf<Any?>(null)
            } catch (exception: Throwable) {
              wrapped = wrapError(exception)
            }
            reply.reply(wrapped)
          }
        } else {
          channel.setMessageHandler(null)
        }
      }
      run {
        val channel = BasicMessageChannel<Any?>(binaryMessenger, "dev.flutter.pigeon.aidlab_sdk.PlatformAidlab.startFirmwareUpdate", codec)
        if (api != null) {
          channel.setMessageHandler { message, reply ->
            val args = message as List<Any?>
            val firmwareUpdateRequestArg = args[0] as FirmwareUpdateRequest
            var wrapped: List<Any?>
            try {
              api.startFirmwareUpdate(firmwareUpdateRequestArg)
              wrapped = listOf<Any?>(null)
            } catch (exception: Throwable) {
              wrapped = wrapError(exception)
            }
            reply.reply(wrapped)
          }
        } else {
          channel.setMessageHandler(null)
        }
      }
    }
  }
}
@Suppress("UNCHECKED_CAST")
private object PlatformAidlabSynchronizationDelegateCodec : StandardMessageCodec() {
  override fun readValueOfType(type: Byte, buffer: ByteBuffer): Any? {
    return when (type) {
      128.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          ActivityEvent.fromList(it)
        }
      }
      129.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          BodyPositionEvent.fromList(it)
        }
      }
      130.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          EcgEvent.fromList(it)
        }
      }
      131.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          HeartRateEvent.fromList(it)
        }
      }
      132.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          OrientationEvent.fromList(it)
        }
      }
      133.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          PressureEvent.fromList(it)
        }
      }
      134.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          QuaternionEvent.fromList(it)
        }
      }
      135.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          RespirationEvent.fromList(it)
        }
      }
      136.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          RespirationRateEvent.fromList(it)
        }
      }
      137.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          RrEvent.fromList(it)
        }
      }
      138.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          SignalQualityEvent.fromList(it)
        }
      }
      139.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          SkinTemperatureEvent.fromList(it)
        }
      }
      140.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          SoundFeaturesEvent.fromList(it)
        }
      }
      141.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          SoundVolumeEvent.fromList(it)
        }
      }
      142.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          StepsEvent.fromList(it)
        }
      }
      143.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          SyncStateEvent.fromList(it)
        }
      }
      144.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          UnsynchronizedSizeEvent.fromList(it)
        }
      }
      145.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          UserEvent.fromList(it)
        }
      }
      146.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          VectorEvent.fromList(it)
        }
      }
      else -> super.readValueOfType(type, buffer)
    }
  }
  override fun writeValue(stream: ByteArrayOutputStream, value: Any?)   {
    when (value) {
      is ActivityEvent -> {
        stream.write(128)
        writeValue(stream, value.toList())
      }
      is BodyPositionEvent -> {
        stream.write(129)
        writeValue(stream, value.toList())
      }
      is EcgEvent -> {
        stream.write(130)
        writeValue(stream, value.toList())
      }
      is HeartRateEvent -> {
        stream.write(131)
        writeValue(stream, value.toList())
      }
      is OrientationEvent -> {
        stream.write(132)
        writeValue(stream, value.toList())
      }
      is PressureEvent -> {
        stream.write(133)
        writeValue(stream, value.toList())
      }
      is QuaternionEvent -> {
        stream.write(134)
        writeValue(stream, value.toList())
      }
      is RespirationEvent -> {
        stream.write(135)
        writeValue(stream, value.toList())
      }
      is RespirationRateEvent -> {
        stream.write(136)
        writeValue(stream, value.toList())
      }
      is RrEvent -> {
        stream.write(137)
        writeValue(stream, value.toList())
      }
      is SignalQualityEvent -> {
        stream.write(138)
        writeValue(stream, value.toList())
      }
      is SkinTemperatureEvent -> {
        stream.write(139)
        writeValue(stream, value.toList())
      }
      is SoundFeaturesEvent -> {
        stream.write(140)
        writeValue(stream, value.toList())
      }
      is SoundVolumeEvent -> {
        stream.write(141)
        writeValue(stream, value.toList())
      }
      is StepsEvent -> {
        stream.write(142)
        writeValue(stream, value.toList())
      }
      is SyncStateEvent -> {
        stream.write(143)
        writeValue(stream, value.toList())
      }
      is UnsynchronizedSizeEvent -> {
        stream.write(144)
        writeValue(stream, value.toList())
      }
      is UserEvent -> {
        stream.write(145)
        writeValue(stream, value.toList())
      }
      is VectorEvent -> {
        stream.write(146)
        writeValue(stream, value.toList())
      }
      else -> super.writeValue(stream, value)
    }
  }
}

/** Generated class from Pigeon that represents Flutter messages that can be called from Kotlin. */
@Suppress("UNCHECKED_CAST")
class PlatformAidlabSynchronizationDelegate(private val binaryMessenger: BinaryMessenger) {
  companion object {
    /** The codec used by PlatformAidlabSynchronizationDelegate. */
    val codec: MessageCodec<Any?> by lazy {
      PlatformAidlabSynchronizationDelegateCodec
    }
  }
  fun syncStateDidChange(syncStateEventArg: SyncStateEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.syncStateDidChange"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(syncStateEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastECG(ecgEventArg: EcgEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastECG"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(ecgEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastRespiration(respirationEventArg: RespirationEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastRespiration"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(respirationEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastSkinTemperature(skinTemperatureEventArg: SkinTemperatureEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSkinTemperature"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(skinTemperatureEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastHeartRate(heartRateEventArg: HeartRateEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastHeartRate"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(heartRateEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastRr(rrEventArg: RrEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastRr"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(rrEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveUnsynchronizedSize(unsynchronizedSizeEventArg: UnsynchronizedSizeEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceiveUnsynchronizedSize"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(unsynchronizedSizeEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastRespirationRate(respirationRateEventArg: RespirationRateEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastRespirationRate"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(respirationRateEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastActivity(activityEventArg: ActivityEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastActivity"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(activityEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastSteps(stepsEventArg: StepsEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSteps"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(stepsEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastSoundVolume(soundVolumeEventArg: SoundVolumeEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSoundVolume"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(soundVolumeEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastAccelerometer(vectorEventArg: VectorEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastAccelerometer"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(vectorEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastGyroscope(vectorEventArg: VectorEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastGyroscope"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(vectorEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastMagnetometer(vectorEventArg: VectorEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastMagnetometer"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(vectorEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastQuaternion(quaternionEventArg: QuaternionEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastQuaternion"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(quaternionEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastOrientation(orientationEventArg: OrientationEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastOrientation"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(orientationEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastBodyPosition(bodyPositionEventArg: BodyPositionEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastBodyPosition"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(bodyPositionEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastPressure(pressureEventArg: PressureEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastPressure"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(pressureEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didDetectPastUserEvent(userEventArg: UserEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didDetectPastUserEvent"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(userEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastSoundFeatures(soundFeaturesEventArg: SoundFeaturesEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSoundFeatures"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(soundFeaturesEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastSignalQuality(signalQualityEventArg: SignalQualityEvent, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSignalQuality"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(signalQualityEventArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
}
