// Autogenerated from Pigeon (v17.0.0), do not edit directly.
// See also: https://pub.dev/packages/pigeon

import Foundation

#if os(iOS)
  import Flutter
#elseif os(macOS)
  import FlutterMacOS
#else
  #error("Unsupported platform.")
#endif

private func wrapResult(_ result: Any?) -> [Any?] {
  return [result]
}

private func wrapError(_ error: Any) -> [Any?] {
  if let flutterError = error as? FlutterError {
    return [
      flutterError.code,
      flutterError.message,
      flutterError.details,
    ]
  }
  return [
    "\(error)",
    "\(type(of: error))",
    "Stacktrace: \(Thread.callStackSymbols)",
  ]
}

private func createConnectionError(withChannelName channelName: String) -> FlutterError {
  return FlutterError(code: "channel-error", message: "Unable to establish connection on channel: '\(channelName)'.", details: "")
}

private func isNullish(_ value: Any?) -> Bool {
  return value is NSNull || value == nil
}

private func nilOrValue<T>(_ value: Any?) -> T? {
  if value is NSNull { return nil }
  return value as! T?
}

/// Generated class from Pigeon that represents data sent in messages.
struct ScanModeRequest {
  var mode: Int64? = nil

  static func fromList(_ list: [Any?]) -> ScanModeRequest? {
    let mode: Int64? = isNullish(list[0]) ? nil : (list[0] is Int64? ? list[0] as! Int64? : Int64(list[0] as! Int32))

    return ScanModeRequest(
      mode: mode
    )
  }
  func toList() -> [Any?] {
    return [
      mode
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct ConnectRequest {
  var address: String? = nil
  var signals: FlutterStandardTypedData? = nil

  static func fromList(_ list: [Any?]) -> ConnectRequest? {
    let address: String? = nilOrValue(list[0])
    let signals: FlutterStandardTypedData? = nilOrValue(list[1])

    return ConnectRequest(
      address: address,
      signals: signals
    )
  }
  func toList() -> [Any?] {
    return [
      address,
      signals,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct AidlabDetectedEvent {
  var address: String? = nil
  var rssi: Int64? = nil

  static func fromList(_ list: [Any?]) -> AidlabDetectedEvent? {
    let address: String? = nilOrValue(list[0])
    let rssi: Int64? = isNullish(list[1]) ? nil : (list[1] is Int64? ? list[1] as! Int64? : Int64(list[1] as! Int32))

    return AidlabDetectedEvent(
      address: address,
      rssi: rssi
    )
  }
  func toList() -> [Any?] {
    return [
      address,
      rssi,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct ScanFailedEvent {
  var errorCode: Int64? = nil

  static func fromList(_ list: [Any?]) -> ScanFailedEvent? {
    let errorCode: Int64? = isNullish(list[0]) ? nil : (list[0] is Int64? ? list[0] as! Int64? : Int64(list[0] as! Int32))

    return ScanFailedEvent(
      errorCode: errorCode
    )
  }
  func toList() -> [Any?] {
    return [
      errorCode
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct LogEvent {
  var msg: String? = nil

  static func fromList(_ list: [Any?]) -> LogEvent? {
    let msg: String? = nilOrValue(list[0])

    return LogEvent(
      msg: msg
    )
  }
  func toList() -> [Any?] {
    return [
      msg
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct ConnectEvent {
  var firmwareRevision: String
  var hardwareRevision: String
  var serialNumber: String
  var address: String

  static func fromList(_ list: [Any?]) -> ConnectEvent? {
    let firmwareRevision = list[0] as! String
    let hardwareRevision = list[1] as! String
    let serialNumber = list[2] as! String
    let address = list[3] as! String

    return ConnectEvent(
      firmwareRevision: firmwareRevision,
      hardwareRevision: hardwareRevision,
      serialNumber: serialNumber,
      address: address
    )
  }
  func toList() -> [Any?] {
    return [
      firmwareRevision,
      hardwareRevision,
      serialNumber,
      address,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct EcgEvent {
  var timestamp: Int64
  var values: FlutterStandardTypedData

  static func fromList(_ list: [Any?]) -> EcgEvent? {
    let timestamp = list[0] is Int64 ? list[0] as! Int64 : Int64(list[0] as! Int32)
    let values = list[1] as! FlutterStandardTypedData

    return EcgEvent(
      timestamp: timestamp,
      values: values
    )
  }
  func toList() -> [Any?] {
    return [
      timestamp,
      values,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct RespirationEvent {
  var timestamp: Int64
  var values: FlutterStandardTypedData

  static func fromList(_ list: [Any?]) -> RespirationEvent? {
    let timestamp = list[0] is Int64 ? list[0] as! Int64 : Int64(list[0] as! Int32)
    let values = list[1] as! FlutterStandardTypedData

    return RespirationEvent(
      timestamp: timestamp,
      values: values
    )
  }
  func toList() -> [Any?] {
    return [
      timestamp,
      values,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct RespirationRateEvent {
  var timestamp: Int64
  var value: Int64

  static func fromList(_ list: [Any?]) -> RespirationRateEvent? {
    let timestamp = list[0] is Int64 ? list[0] as! Int64 : Int64(list[0] as! Int32)
    let value = list[1] is Int64 ? list[1] as! Int64 : Int64(list[1] as! Int32)

    return RespirationRateEvent(
      timestamp: timestamp,
      value: value
    )
  }
  func toList() -> [Any?] {
    return [
      timestamp,
      value,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct BatteryLevelEvent {
  var stateOfCharge: Int64

  static func fromList(_ list: [Any?]) -> BatteryLevelEvent? {
    let stateOfCharge = list[0] is Int64 ? list[0] as! Int64 : Int64(list[0] as! Int32)

    return BatteryLevelEvent(
      stateOfCharge: stateOfCharge
    )
  }
  func toList() -> [Any?] {
    return [
      stateOfCharge
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct VectorEvent {
  var timestamp: Int64
  var x: Double
  var y: Double
  var z: Double

  static func fromList(_ list: [Any?]) -> VectorEvent? {
    let timestamp = list[0] is Int64 ? list[0] as! Int64 : Int64(list[0] as! Int32)
    let x = list[1] as! Double
    let y = list[2] as! Double
    let z = list[3] as! Double

    return VectorEvent(
      timestamp: timestamp,
      x: x,
      y: y,
      z: z
    )
  }
  func toList() -> [Any?] {
    return [
      timestamp,
      x,
      y,
      z,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct QuaternionEvent {
  var timestamp: Int64
  var qw: Double
  var qx: Double
  var qy: Double
  var qz: Double

  static func fromList(_ list: [Any?]) -> QuaternionEvent? {
    let timestamp = list[0] is Int64 ? list[0] as! Int64 : Int64(list[0] as! Int32)
    let qw = list[1] as! Double
    let qx = list[2] as! Double
    let qy = list[3] as! Double
    let qz = list[4] as! Double

    return QuaternionEvent(
      timestamp: timestamp,
      qw: qw,
      qx: qx,
      qy: qy,
      qz: qz
    )
  }
  func toList() -> [Any?] {
    return [
      timestamp,
      qw,
      qx,
      qy,
      qz,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct OrientationEvent {
  var timestamp: Int64
  var roll: Double
  var pitch: Double
  var yaw: Double

  static func fromList(_ list: [Any?]) -> OrientationEvent? {
    let timestamp = list[0] is Int64 ? list[0] as! Int64 : Int64(list[0] as! Int32)
    let roll = list[1] as! Double
    let pitch = list[2] as! Double
    let yaw = list[3] as! Double

    return OrientationEvent(
      timestamp: timestamp,
      roll: roll,
      pitch: pitch,
      yaw: yaw
    )
  }
  func toList() -> [Any?] {
    return [
      timestamp,
      roll,
      pitch,
      yaw,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct BodyPositionEvent {
  var timestamp: Int64
  var bodyPosition: Int64

  static func fromList(_ list: [Any?]) -> BodyPositionEvent? {
    let timestamp = list[0] is Int64 ? list[0] as! Int64 : Int64(list[0] as! Int32)
    let bodyPosition = list[1] is Int64 ? list[1] as! Int64 : Int64(list[1] as! Int32)

    return BodyPositionEvent(
      timestamp: timestamp,
      bodyPosition: bodyPosition
    )
  }
  func toList() -> [Any?] {
    return [
      timestamp,
      bodyPosition,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct ActivityEvent {
  var timestamp: Int64
  var activityType: Int64

  static func fromList(_ list: [Any?]) -> ActivityEvent? {
    let timestamp = list[0] is Int64 ? list[0] as! Int64 : Int64(list[0] as! Int32)
    let activityType = list[1] is Int64 ? list[1] as! Int64 : Int64(list[1] as! Int32)

    return ActivityEvent(
      timestamp: timestamp,
      activityType: activityType
    )
  }
  func toList() -> [Any?] {
    return [
      timestamp,
      activityType,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct StepsEvent {
  var timestamp: Int64
  var value: Int64

  static func fromList(_ list: [Any?]) -> StepsEvent? {
    let timestamp = list[0] is Int64 ? list[0] as! Int64 : Int64(list[0] as! Int32)
    let value = list[1] is Int64 ? list[1] as! Int64 : Int64(list[1] as! Int32)

    return StepsEvent(
      timestamp: timestamp,
      value: value
    )
  }
  func toList() -> [Any?] {
    return [
      timestamp,
      value,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct HeartRateEvent {
  var timestamp: Int64
  var heartRate: Int64

  static func fromList(_ list: [Any?]) -> HeartRateEvent? {
    let timestamp = list[0] is Int64 ? list[0] as! Int64 : Int64(list[0] as! Int32)
    let heartRate = list[1] is Int64 ? list[1] as! Int64 : Int64(list[1] as! Int32)

    return HeartRateEvent(
      timestamp: timestamp,
      heartRate: heartRate
    )
  }
  func toList() -> [Any?] {
    return [
      timestamp,
      heartRate,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct RrEvent {
  var timestamp: Int64
  var rr: Int64

  static func fromList(_ list: [Any?]) -> RrEvent? {
    let timestamp = list[0] is Int64 ? list[0] as! Int64 : Int64(list[0] as! Int32)
    let rr = list[1] is Int64 ? list[1] as! Int64 : Int64(list[1] as! Int32)

    return RrEvent(
      timestamp: timestamp,
      rr: rr
    )
  }
  func toList() -> [Any?] {
    return [
      timestamp,
      rr,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct WearStateEvent {
  var wearState: Int64

  static func fromList(_ list: [Any?]) -> WearStateEvent? {
    let wearState = list[0] is Int64 ? list[0] as! Int64 : Int64(list[0] as! Int32)

    return WearStateEvent(
      wearState: wearState
    )
  }
  func toList() -> [Any?] {
    return [
      wearState
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct SkinTemperatureEvent {
  var timestamp: Int64
  var value: Double

  static func fromList(_ list: [Any?]) -> SkinTemperatureEvent? {
    let timestamp = list[0] is Int64 ? list[0] as! Int64 : Int64(list[0] as! Int32)
    let value = list[1] as! Double

    return SkinTemperatureEvent(
      timestamp: timestamp,
      value: value
    )
  }
  func toList() -> [Any?] {
    return [
      timestamp,
      value,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct ExerciseEvent {
  var exercise: Int64? = nil

  static func fromList(_ list: [Any?]) -> ExerciseEvent? {
    let exercise: Int64? = isNullish(list[0]) ? nil : (list[0] is Int64? ? list[0] as! Int64? : Int64(list[0] as! Int32))

    return ExerciseEvent(
      exercise: exercise
    )
  }
  func toList() -> [Any?] {
    return [
      exercise
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct SoundVolumeEvent {
  var timestamp: Int64
  var soundVolume: Int64

  static func fromList(_ list: [Any?]) -> SoundVolumeEvent? {
    let timestamp = list[0] is Int64 ? list[0] as! Int64 : Int64(list[0] as! Int32)
    let soundVolume = list[1] is Int64 ? list[1] as! Int64 : Int64(list[1] as! Int32)

    return SoundVolumeEvent(
      timestamp: timestamp,
      soundVolume: soundVolume
    )
  }
  func toList() -> [Any?] {
    return [
      timestamp,
      soundVolume,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct ErrorEvent {
  var error: String

  static func fromList(_ list: [Any?]) -> ErrorEvent? {
    let error = list[0] as! String

    return ErrorEvent(
      error: error
    )
  }
  func toList() -> [Any?] {
    return [
      error
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct MessageEvent {
  var process: String
  var message: String

  static func fromList(_ list: [Any?]) -> MessageEvent? {
    let process = list[0] as! String
    let message = list[1] as! String

    return MessageEvent(
      process: process,
      message: message
    )
  }
  func toList() -> [Any?] {
    return [
      process,
      message,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct UserEvent {
  var timestamp: Int64

  static func fromList(_ list: [Any?]) -> UserEvent? {
    let timestamp = list[0] is Int64 ? list[0] as! Int64 : Int64(list[0] as! Int32)

    return UserEvent(
      timestamp: timestamp
    )
  }
  func toList() -> [Any?] {
    return [
      timestamp
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct SoundFeaturesEvent {
  var values: FlutterStandardTypedData

  static func fromList(_ list: [Any?]) -> SoundFeaturesEvent? {
    let values = list[0] as! FlutterStandardTypedData

    return SoundFeaturesEvent(
      values: values
    )
  }
  func toList() -> [Any?] {
    return [
      values
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct DisconnectEvent {
  var disconnectReason: Int64

  static func fromList(_ list: [Any?]) -> DisconnectEvent? {
    let disconnectReason = list[0] is Int64 ? list[0] as! Int64 : Int64(list[0] as! Int32)

    return DisconnectEvent(
      disconnectReason: disconnectReason
    )
  }
  func toList() -> [Any?] {
    return [
      disconnectReason
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct SignalQualityEvent {
  var timestamp: Int64
  var value: Int64

  static func fromList(_ list: [Any?]) -> SignalQualityEvent? {
    let timestamp = list[0] is Int64 ? list[0] as! Int64 : Int64(list[0] as! Int32)
    let value = list[1] is Int64 ? list[1] as! Int64 : Int64(list[1] as! Int32)

    return SignalQualityEvent(
      timestamp: timestamp,
      value: value
    )
  }
  func toList() -> [Any?] {
    return [
      timestamp,
      value,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct FirmwareInformationEvent {
  var updateAvailable: Bool? = nil
  var updatableVersion: String? = nil

  static func fromList(_ list: [Any?]) -> FirmwareInformationEvent? {
    let updateAvailable: Bool? = nilOrValue(list[0])
    let updatableVersion: String? = nilOrValue(list[1])

    return FirmwareInformationEvent(
      updateAvailable: updateAvailable,
      updatableVersion: updatableVersion
    )
  }
  func toList() -> [Any?] {
    return [
      updateAvailable,
      updatableVersion,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct PressureEvent {
  var timestamp: Int64? = nil
  var values: FlutterStandardTypedData? = nil

  static func fromList(_ list: [Any?]) -> PressureEvent? {
    let timestamp: Int64? = isNullish(list[0]) ? nil : (list[0] is Int64? ? list[0] as! Int64? : Int64(list[0] as! Int32))
    let values: FlutterStandardTypedData? = nilOrValue(list[1])

    return PressureEvent(
      timestamp: timestamp,
      values: values
    )
  }
  func toList() -> [Any?] {
    return [
      timestamp,
      values,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct PressureWearStateEvent {
  var wearState: Int64? = nil

  static func fromList(_ list: [Any?]) -> PressureWearStateEvent? {
    let wearState: Int64? = isNullish(list[0]) ? nil : (list[0] is Int64? ? list[0] as! Int64? : Int64(list[0] as! Int32))

    return PressureWearStateEvent(
      wearState: wearState
    )
  }
  func toList() -> [Any?] {
    return [
      wearState
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct UpdateProgress {
  var progress: Int64? = nil

  static func fromList(_ list: [Any?]) -> UpdateProgress? {
    let progress: Int64? = isNullish(list[0]) ? nil : (list[0] is Int64? ? list[0] as! Int64? : Int64(list[0] as! Int32))

    return UpdateProgress(
      progress: progress
    )
  }
  func toList() -> [Any?] {
    return [
      progress
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct UpdateEvent {
  var error: Int64? = nil

  static func fromList(_ list: [Any?]) -> UpdateEvent? {
    let error: Int64? = isNullish(list[0]) ? nil : (list[0] is Int64? ? list[0] as! Int64? : Int64(list[0] as! Int32))

    return UpdateEvent(
      error: error
    )
  }
  func toList() -> [Any?] {
    return [
      error
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct SendRequest {
  var command: String

  static func fromList(_ list: [Any?]) -> SendRequest? {
    let command = list[0] as! String

    return SendRequest(
      command: command
    )
  }
  func toList() -> [Any?] {
    return [
      command
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct EcgFiltrationRequest {
  var method: Int64

  static func fromList(_ list: [Any?]) -> EcgFiltrationRequest? {
    let method = list[0] is Int64 ? list[0] as! Int64 : Int64(list[0] as! Int32)

    return EcgFiltrationRequest(
      method: method
    )
  }
  func toList() -> [Any?] {
    return [
      method
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct FirmwareInfoRequest {
  var url: String

  static func fromList(_ list: [Any?]) -> FirmwareInfoRequest? {
    let url = list[0] as! String

    return FirmwareInfoRequest(
      url: url
    )
  }
  func toList() -> [Any?] {
    return [
      url
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct FirmwareUpdateRequest {
  var url: String
  var updatableVersion: String

  static func fromList(_ list: [Any?]) -> FirmwareUpdateRequest? {
    let url = list[0] as! String
    let updatableVersion = list[1] as! String

    return FirmwareUpdateRequest(
      url: url,
      updatableVersion: updatableVersion
    )
  }
  func toList() -> [Any?] {
    return [
      url,
      updatableVersion,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct SyncStateEvent {
  var state: Int64

  static func fromList(_ list: [Any?]) -> SyncStateEvent? {
    let state = list[0] is Int64 ? list[0] as! Int64 : Int64(list[0] as! Int32)

    return SyncStateEvent(
      state: state
    )
  }
  func toList() -> [Any?] {
    return [
      state
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct UnsynchronizedSizeEvent {
  var unsynchronizedSize: Int64
  var syncBytesPerSecond: Double

  static func fromList(_ list: [Any?]) -> UnsynchronizedSizeEvent? {
    let unsynchronizedSize = list[0] is Int64 ? list[0] as! Int64 : Int64(list[0] as! Int32)
    let syncBytesPerSecond = list[1] as! Double

    return UnsynchronizedSizeEvent(
      unsynchronizedSize: unsynchronizedSize,
      syncBytesPerSecond: syncBytesPerSecond
    )
  }
  func toList() -> [Any?] {
    return [
      unsynchronizedSize,
      syncBytesPerSecond,
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct EmptyEvent {
  var nothing: Int64

  static func fromList(_ list: [Any?]) -> EmptyEvent? {
    let nothing = list[0] is Int64 ? list[0] as! Int64 : Int64(list[0] as! Int32)

    return EmptyEvent(
      nothing: nothing
    )
  }
  func toList() -> [Any?] {
    return [
      nothing
    ]
  }
}
private class PlatformAidlabSdkCodecReader: FlutterStandardReader {
  override func readValue(ofType type: UInt8) -> Any? {
    switch type {
    case 128:
      return ConnectRequest.fromList(self.readValue() as! [Any?])
    case 129:
      return ScanModeRequest.fromList(self.readValue() as! [Any?])
    default:
      return super.readValue(ofType: type)
    }
  }
}

private class PlatformAidlabSdkCodecWriter: FlutterStandardWriter {
  override func writeValue(_ value: Any) {
    if let value = value as? ConnectRequest {
      super.writeByte(128)
      super.writeValue(value.toList())
    } else if let value = value as? ScanModeRequest {
      super.writeByte(129)
      super.writeValue(value.toList())
    } else {
      super.writeValue(value)
    }
  }
}

private class PlatformAidlabSdkCodecReaderWriter: FlutterStandardReaderWriter {
  override func reader(with data: Data) -> FlutterStandardReader {
    return PlatformAidlabSdkCodecReader(data: data)
  }

  override func writer(with data: NSMutableData) -> FlutterStandardWriter {
    return PlatformAidlabSdkCodecWriter(data: data)
  }
}

class PlatformAidlabSdkCodec: FlutterStandardMessageCodec {
  static let shared = PlatformAidlabSdkCodec(readerWriter: PlatformAidlabSdkCodecReaderWriter())
}

/// Generated protocol from Pigeon that represents a handler of messages from Flutter.
protocol PlatformAidlabSdk {
  func initSdk() throws
  func scanForDevices(scanMode: ScanModeRequest) throws
  func stopDeviceScan() throws
  func connect(request: ConnectRequest) throws
}

/// Generated setup class from Pigeon to handle messages through the `binaryMessenger`.
class PlatformAidlabSdkSetup {
  /// The codec used by PlatformAidlabSdk.
  static var codec: FlutterStandardMessageCodec { PlatformAidlabSdkCodec.shared }
  /// Sets up an instance of `PlatformAidlabSdk` to handle messages through the `binaryMessenger`.
  static func setUp(binaryMessenger: FlutterBinaryMessenger, api: PlatformAidlabSdk?) {
    let initSdkChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdk.initSdk", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      initSdkChannel.setMessageHandler { _, reply in
        do {
          try api.initSdk()
          reply(wrapResult(nil))
        } catch {
          reply(wrapError(error))
        }
      }
    } else {
      initSdkChannel.setMessageHandler(nil)
    }
    let scanForDevicesChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdk.scanForDevices", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      scanForDevicesChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let scanModeArg = args[0] as! ScanModeRequest
        do {
          try api.scanForDevices(scanMode: scanModeArg)
          reply(wrapResult(nil))
        } catch {
          reply(wrapError(error))
        }
      }
    } else {
      scanForDevicesChannel.setMessageHandler(nil)
    }
    let stopDeviceScanChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdk.stopDeviceScan", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      stopDeviceScanChannel.setMessageHandler { _, reply in
        do {
          try api.stopDeviceScan()
          reply(wrapResult(nil))
        } catch {
          reply(wrapError(error))
        }
      }
    } else {
      stopDeviceScanChannel.setMessageHandler(nil)
    }
    let connectChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdk.connect", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      connectChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let requestArg = args[0] as! ConnectRequest
        do {
          try api.connect(request: requestArg)
          reply(wrapResult(nil))
        } catch {
          reply(wrapError(error))
        }
      }
    } else {
      connectChannel.setMessageHandler(nil)
    }
  }
}
private class PlatformAidlabSdkDelegateCodecReader: FlutterStandardReader {
  override func readValue(ofType type: UInt8) -> Any? {
    switch type {
    case 128:
      return AidlabDetectedEvent.fromList(self.readValue() as! [Any?])
    case 129:
      return EmptyEvent.fromList(self.readValue() as! [Any?])
    case 130:
      return ScanFailedEvent.fromList(self.readValue() as! [Any?])
    default:
      return super.readValue(ofType: type)
    }
  }
}

private class PlatformAidlabSdkDelegateCodecWriter: FlutterStandardWriter {
  override func writeValue(_ value: Any) {
    if let value = value as? AidlabDetectedEvent {
      super.writeByte(128)
      super.writeValue(value.toList())
    } else if let value = value as? EmptyEvent {
      super.writeByte(129)
      super.writeValue(value.toList())
    } else if let value = value as? ScanFailedEvent {
      super.writeByte(130)
      super.writeValue(value.toList())
    } else {
      super.writeValue(value)
    }
  }
}

private class PlatformAidlabSdkDelegateCodecReaderWriter: FlutterStandardReaderWriter {
  override func reader(with data: Data) -> FlutterStandardReader {
    return PlatformAidlabSdkDelegateCodecReader(data: data)
  }

  override func writer(with data: NSMutableData) -> FlutterStandardWriter {
    return PlatformAidlabSdkDelegateCodecWriter(data: data)
  }
}

class PlatformAidlabSdkDelegateCodec: FlutterStandardMessageCodec {
  static let shared = PlatformAidlabSdkDelegateCodec(readerWriter: PlatformAidlabSdkDelegateCodecReaderWriter())
}

/// Generated protocol from Pigeon that represents Flutter messages that can be called from Swift.
protocol PlatformAidlabSdkDelegateProtocol {
  func onBluetoothStarted(voidEvent voidEventArg: EmptyEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func onDeviceScanStarted(voidEvent voidEventArg: EmptyEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func onDeviceScanStopped(voidEvent voidEventArg: EmptyEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func onScanFailed(event eventArg: ScanFailedEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func onAidlabDetected(event eventArg: AidlabDetectedEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
}
class PlatformAidlabSdkDelegate: PlatformAidlabSdkDelegateProtocol {
  private let binaryMessenger: FlutterBinaryMessenger
  init(binaryMessenger: FlutterBinaryMessenger) {
    self.binaryMessenger = binaryMessenger
  }
  var codec: FlutterStandardMessageCodec {
    return PlatformAidlabSdkDelegateCodec.shared
  }
  func onBluetoothStarted(voidEvent voidEventArg: EmptyEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onBluetoothStarted"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([voidEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func onDeviceScanStarted(voidEvent voidEventArg: EmptyEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onDeviceScanStarted"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([voidEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func onDeviceScanStopped(voidEvent voidEventArg: EmptyEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onDeviceScanStopped"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([voidEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func onScanFailed(event eventArg: ScanFailedEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onScanFailed"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([eventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func onAidlabDetected(event eventArg: AidlabDetectedEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onAidlabDetected"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([eventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
}
private class PlatformAidlabLoggerCodecReader: FlutterStandardReader {
  override func readValue(ofType type: UInt8) -> Any? {
    switch type {
    case 128:
      return LogEvent.fromList(self.readValue() as! [Any?])
    default:
      return super.readValue(ofType: type)
    }
  }
}

private class PlatformAidlabLoggerCodecWriter: FlutterStandardWriter {
  override func writeValue(_ value: Any) {
    if let value = value as? LogEvent {
      super.writeByte(128)
      super.writeValue(value.toList())
    } else {
      super.writeValue(value)
    }
  }
}

private class PlatformAidlabLoggerCodecReaderWriter: FlutterStandardReaderWriter {
  override func reader(with data: Data) -> FlutterStandardReader {
    return PlatformAidlabLoggerCodecReader(data: data)
  }

  override func writer(with data: NSMutableData) -> FlutterStandardWriter {
    return PlatformAidlabLoggerCodecWriter(data: data)
  }
}

class PlatformAidlabLoggerCodec: FlutterStandardMessageCodec {
  static let shared = PlatformAidlabLoggerCodec(readerWriter: PlatformAidlabLoggerCodecReaderWriter())
}

/// Generated protocol from Pigeon that represents Flutter messages that can be called from Swift.
protocol PlatformAidlabLoggerProtocol {
  func onLog(event eventArg: LogEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func onWarning(event eventArg: LogEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func onError(event eventArg: LogEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
}
class PlatformAidlabLogger: PlatformAidlabLoggerProtocol {
  private let binaryMessenger: FlutterBinaryMessenger
  init(binaryMessenger: FlutterBinaryMessenger) {
    self.binaryMessenger = binaryMessenger
  }
  var codec: FlutterStandardMessageCodec {
    return PlatformAidlabLoggerCodec.shared
  }
  func onLog(event eventArg: LogEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabLogger.onLog"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([eventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func onWarning(event eventArg: LogEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabLogger.onWarning"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([eventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func onError(event eventArg: LogEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabLogger.onError"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([eventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
}
private class PlatformAidlabDelegateCodecReader: FlutterStandardReader {
  override func readValue(ofType type: UInt8) -> Any? {
    switch type {
    case 128:
      return ActivityEvent.fromList(self.readValue() as! [Any?])
    case 129:
      return BatteryLevelEvent.fromList(self.readValue() as! [Any?])
    case 130:
      return BodyPositionEvent.fromList(self.readValue() as! [Any?])
    case 131:
      return ConnectEvent.fromList(self.readValue() as! [Any?])
    case 132:
      return DisconnectEvent.fromList(self.readValue() as! [Any?])
    case 133:
      return EcgEvent.fromList(self.readValue() as! [Any?])
    case 134:
      return EmptyEvent.fromList(self.readValue() as! [Any?])
    case 135:
      return ErrorEvent.fromList(self.readValue() as! [Any?])
    case 136:
      return ExerciseEvent.fromList(self.readValue() as! [Any?])
    case 137:
      return HeartRateEvent.fromList(self.readValue() as! [Any?])
    case 138:
      return MessageEvent.fromList(self.readValue() as! [Any?])
    case 139:
      return OrientationEvent.fromList(self.readValue() as! [Any?])
    case 140:
      return QuaternionEvent.fromList(self.readValue() as! [Any?])
    case 141:
      return RespirationEvent.fromList(self.readValue() as! [Any?])
    case 142:
      return RespirationRateEvent.fromList(self.readValue() as! [Any?])
    case 143:
      return RrEvent.fromList(self.readValue() as! [Any?])
    case 144:
      return SignalQualityEvent.fromList(self.readValue() as! [Any?])
    case 145:
      return SkinTemperatureEvent.fromList(self.readValue() as! [Any?])
    case 146:
      return SoundFeaturesEvent.fromList(self.readValue() as! [Any?])
    case 147:
      return SoundVolumeEvent.fromList(self.readValue() as! [Any?])
    case 148:
      return StepsEvent.fromList(self.readValue() as! [Any?])
    case 149:
      return UserEvent.fromList(self.readValue() as! [Any?])
    case 150:
      return VectorEvent.fromList(self.readValue() as! [Any?])
    case 151:
      return WearStateEvent.fromList(self.readValue() as! [Any?])
    default:
      return super.readValue(ofType: type)
    }
  }
}

private class PlatformAidlabDelegateCodecWriter: FlutterStandardWriter {
  override func writeValue(_ value: Any) {
    if let value = value as? ActivityEvent {
      super.writeByte(128)
      super.writeValue(value.toList())
    } else if let value = value as? BatteryLevelEvent {
      super.writeByte(129)
      super.writeValue(value.toList())
    } else if let value = value as? BodyPositionEvent {
      super.writeByte(130)
      super.writeValue(value.toList())
    } else if let value = value as? ConnectEvent {
      super.writeByte(131)
      super.writeValue(value.toList())
    } else if let value = value as? DisconnectEvent {
      super.writeByte(132)
      super.writeValue(value.toList())
    } else if let value = value as? EcgEvent {
      super.writeByte(133)
      super.writeValue(value.toList())
    } else if let value = value as? EmptyEvent {
      super.writeByte(134)
      super.writeValue(value.toList())
    } else if let value = value as? ErrorEvent {
      super.writeByte(135)
      super.writeValue(value.toList())
    } else if let value = value as? ExerciseEvent {
      super.writeByte(136)
      super.writeValue(value.toList())
    } else if let value = value as? HeartRateEvent {
      super.writeByte(137)
      super.writeValue(value.toList())
    } else if let value = value as? MessageEvent {
      super.writeByte(138)
      super.writeValue(value.toList())
    } else if let value = value as? OrientationEvent {
      super.writeByte(139)
      super.writeValue(value.toList())
    } else if let value = value as? QuaternionEvent {
      super.writeByte(140)
      super.writeValue(value.toList())
    } else if let value = value as? RespirationEvent {
      super.writeByte(141)
      super.writeValue(value.toList())
    } else if let value = value as? RespirationRateEvent {
      super.writeByte(142)
      super.writeValue(value.toList())
    } else if let value = value as? RrEvent {
      super.writeByte(143)
      super.writeValue(value.toList())
    } else if let value = value as? SignalQualityEvent {
      super.writeByte(144)
      super.writeValue(value.toList())
    } else if let value = value as? SkinTemperatureEvent {
      super.writeByte(145)
      super.writeValue(value.toList())
    } else if let value = value as? SoundFeaturesEvent {
      super.writeByte(146)
      super.writeValue(value.toList())
    } else if let value = value as? SoundVolumeEvent {
      super.writeByte(147)
      super.writeValue(value.toList())
    } else if let value = value as? StepsEvent {
      super.writeByte(148)
      super.writeValue(value.toList())
    } else if let value = value as? UserEvent {
      super.writeByte(149)
      super.writeValue(value.toList())
    } else if let value = value as? VectorEvent {
      super.writeByte(150)
      super.writeValue(value.toList())
    } else if let value = value as? WearStateEvent {
      super.writeByte(151)
      super.writeValue(value.toList())
    } else {
      super.writeValue(value)
    }
  }
}

private class PlatformAidlabDelegateCodecReaderWriter: FlutterStandardReaderWriter {
  override func reader(with data: Data) -> FlutterStandardReader {
    return PlatformAidlabDelegateCodecReader(data: data)
  }

  override func writer(with data: NSMutableData) -> FlutterStandardWriter {
    return PlatformAidlabDelegateCodecWriter(data: data)
  }
}

class PlatformAidlabDelegateCodec: FlutterStandardMessageCodec {
  static let shared = PlatformAidlabDelegateCodec(readerWriter: PlatformAidlabDelegateCodecReaderWriter())
}

/// Generated protocol from Pigeon that represents Flutter messages that can be called from Swift.
protocol PlatformAidlabDelegateProtocol {
  func didConnect(connectEvent connectEventArg: ConnectEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didDisconnect(voidEvent voidEventArg: DisconnectEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveEcg(ecgEvent ecgEventArg: EcgEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveRespiration(respirationEvent respirationEventArg: RespirationEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveRespirationRate(respirationRateEvent respirationRateEventArg: RespirationRateEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveBatteryLevel(batteryLevelEvent batteryLevelEventArg: BatteryLevelEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveSkinTemperature(skinTemperatureEvent skinTemperatureEventArg: SkinTemperatureEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveAccelerometer(vectorEvent vectorEventArg: VectorEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveGyroscope(vectorEvent vectorEventArg: VectorEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveMagnetometer(vectorEvent vectorEventArg: VectorEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveQuaternion(quaternionEvent quaternionEventArg: QuaternionEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveOrientation(orientationEvent orientationEventArg: OrientationEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveBodyPosition(bodyPositionEvent bodyPositionEventArg: BodyPositionEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveActivity(activityEvent activityEventArg: ActivityEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveSteps(stepsEvent stepsEventArg: StepsEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveHeartRate(heartRateEvent heartRateEventArg: HeartRateEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveRr(rrEvent rrEventArg: RrEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func wearStateDidChange(wearStateEvent wearStateEventArg: WearStateEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didDetectExercise(exerciseEvent exerciseEventArg: ExerciseEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveSoundVolume(soundVolumeEvent soundVolumeEventArg: SoundVolumeEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveCommand(voidEvent voidEventArg: EmptyEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveError(errorEvent errorEventArg: ErrorEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveMessage(messageEvent messageEventArg: MessageEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didDetectUserEvent(userEvent userEventArg: UserEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveSoundFeatures(soundFeaturesEvent soundFeaturesEventArg: SoundFeaturesEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveSignalQuality(signalQualityEvent signalQualityEventArg: SignalQualityEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
}
class PlatformAidlabDelegate: PlatformAidlabDelegateProtocol {
  private let binaryMessenger: FlutterBinaryMessenger
  init(binaryMessenger: FlutterBinaryMessenger) {
    self.binaryMessenger = binaryMessenger
  }
  var codec: FlutterStandardMessageCodec {
    return PlatformAidlabDelegateCodec.shared
  }
  func didConnect(connectEvent connectEventArg: ConnectEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didConnect"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([connectEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didDisconnect(voidEvent voidEventArg: DisconnectEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didDisconnect"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([voidEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveEcg(ecgEvent ecgEventArg: EcgEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveEcg"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([ecgEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveRespiration(respirationEvent respirationEventArg: RespirationEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveRespiration"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([respirationEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveRespirationRate(respirationRateEvent respirationRateEventArg: RespirationRateEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveRespirationRate"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([respirationRateEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveBatteryLevel(batteryLevelEvent batteryLevelEventArg: BatteryLevelEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveBatteryLevel"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([batteryLevelEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveSkinTemperature(skinTemperatureEvent skinTemperatureEventArg: SkinTemperatureEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSkinTemperature"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([skinTemperatureEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveAccelerometer(vectorEvent vectorEventArg: VectorEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveAccelerometer"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([vectorEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveGyroscope(vectorEvent vectorEventArg: VectorEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveGyroscope"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([vectorEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveMagnetometer(vectorEvent vectorEventArg: VectorEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveMagnetometer"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([vectorEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveQuaternion(quaternionEvent quaternionEventArg: QuaternionEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveQuaternion"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([quaternionEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveOrientation(orientationEvent orientationEventArg: OrientationEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveOrientation"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([orientationEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveBodyPosition(bodyPositionEvent bodyPositionEventArg: BodyPositionEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveBodyPosition"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([bodyPositionEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveActivity(activityEvent activityEventArg: ActivityEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveActivity"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([activityEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveSteps(stepsEvent stepsEventArg: StepsEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSteps"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([stepsEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveHeartRate(heartRateEvent heartRateEventArg: HeartRateEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveHeartRate"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([heartRateEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveRr(rrEvent rrEventArg: RrEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveRr"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([rrEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func wearStateDidChange(wearStateEvent wearStateEventArg: WearStateEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.wearStateDidChange"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([wearStateEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didDetectExercise(exerciseEvent exerciseEventArg: ExerciseEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didDetectExercise"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([exerciseEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveSoundVolume(soundVolumeEvent soundVolumeEventArg: SoundVolumeEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSoundVolume"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([soundVolumeEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveCommand(voidEvent voidEventArg: EmptyEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveCommand"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([voidEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveError(errorEvent errorEventArg: ErrorEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveError"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([errorEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveMessage(messageEvent messageEventArg: MessageEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveMessage"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([messageEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didDetectUserEvent(userEvent userEventArg: UserEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didDetectUserEvent"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([userEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveSoundFeatures(soundFeaturesEvent soundFeaturesEventArg: SoundFeaturesEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSoundFeatures"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([soundFeaturesEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveSignalQuality(signalQualityEvent signalQualityEventArg: SignalQualityEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSignalQuality"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([signalQualityEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
}
private class PlatformAidlabInternalDelegateCodecReader: FlutterStandardReader {
  override func readValue(ofType type: UInt8) -> Any? {
    switch type {
    case 128:
      return FirmwareInformationEvent.fromList(self.readValue() as! [Any?])
    case 129:
      return PressureEvent.fromList(self.readValue() as! [Any?])
    case 130:
      return PressureWearStateEvent.fromList(self.readValue() as! [Any?])
    default:
      return super.readValue(ofType: type)
    }
  }
}

private class PlatformAidlabInternalDelegateCodecWriter: FlutterStandardWriter {
  override func writeValue(_ value: Any) {
    if let value = value as? FirmwareInformationEvent {
      super.writeByte(128)
      super.writeValue(value.toList())
    } else if let value = value as? PressureEvent {
      super.writeByte(129)
      super.writeValue(value.toList())
    } else if let value = value as? PressureWearStateEvent {
      super.writeByte(130)
      super.writeValue(value.toList())
    } else {
      super.writeValue(value)
    }
  }
}

private class PlatformAidlabInternalDelegateCodecReaderWriter: FlutterStandardReaderWriter {
  override func reader(with data: Data) -> FlutterStandardReader {
    return PlatformAidlabInternalDelegateCodecReader(data: data)
  }

  override func writer(with data: NSMutableData) -> FlutterStandardWriter {
    return PlatformAidlabInternalDelegateCodecWriter(data: data)
  }
}

class PlatformAidlabInternalDelegateCodec: FlutterStandardMessageCodec {
  static let shared = PlatformAidlabInternalDelegateCodec(readerWriter: PlatformAidlabInternalDelegateCodecReaderWriter())
}

/// Generated protocol from Pigeon that represents Flutter messages that can be called from Swift.
protocol PlatformAidlabInternalDelegateProtocol {
  func didReceiveFirmwareInformation(firmwareInformationEvent firmwareInformationEventArg: FirmwareInformationEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePressure(pressureEvent pressureEventArg: PressureEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func pressureWearStateDidChange(wearStateEvent wearStateEventArg: PressureWearStateEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
}
class PlatformAidlabInternalDelegate: PlatformAidlabInternalDelegateProtocol {
  private let binaryMessenger: FlutterBinaryMessenger
  init(binaryMessenger: FlutterBinaryMessenger) {
    self.binaryMessenger = binaryMessenger
  }
  var codec: FlutterStandardMessageCodec {
    return PlatformAidlabInternalDelegateCodec.shared
  }
  func didReceiveFirmwareInformation(firmwareInformationEvent firmwareInformationEventArg: FirmwareInformationEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabInternalDelegate.didReceiveFirmwareInformation"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([firmwareInformationEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePressure(pressureEvent pressureEventArg: PressureEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabInternalDelegate.didReceivePressure"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([pressureEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func pressureWearStateDidChange(wearStateEvent wearStateEventArg: PressureWearStateEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabInternalDelegate.pressureWearStateDidChange"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([wearStateEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
}
private class PlatformAidlabUpdateDelegateCodecReader: FlutterStandardReader {
  override func readValue(ofType type: UInt8) -> Any? {
    switch type {
    case 128:
      return EmptyEvent.fromList(self.readValue() as! [Any?])
    case 129:
      return UpdateEvent.fromList(self.readValue() as! [Any?])
    case 130:
      return UpdateProgress.fromList(self.readValue() as! [Any?])
    default:
      return super.readValue(ofType: type)
    }
  }
}

private class PlatformAidlabUpdateDelegateCodecWriter: FlutterStandardWriter {
  override func writeValue(_ value: Any) {
    if let value = value as? EmptyEvent {
      super.writeByte(128)
      super.writeValue(value.toList())
    } else if let value = value as? UpdateEvent {
      super.writeByte(129)
      super.writeValue(value.toList())
    } else if let value = value as? UpdateProgress {
      super.writeByte(130)
      super.writeValue(value.toList())
    } else {
      super.writeValue(value)
    }
  }
}

private class PlatformAidlabUpdateDelegateCodecReaderWriter: FlutterStandardReaderWriter {
  override func reader(with data: Data) -> FlutterStandardReader {
    return PlatformAidlabUpdateDelegateCodecReader(data: data)
  }

  override func writer(with data: NSMutableData) -> FlutterStandardWriter {
    return PlatformAidlabUpdateDelegateCodecWriter(data: data)
  }
}

class PlatformAidlabUpdateDelegateCodec: FlutterStandardMessageCodec {
  static let shared = PlatformAidlabUpdateDelegateCodec(readerWriter: PlatformAidlabUpdateDelegateCodecReaderWriter())
}

/// Generated protocol from Pigeon that represents Flutter messages that can be called from Swift.
protocol PlatformAidlabUpdateDelegateProtocol {
  func didFinishUpdate(nothing nothingArg: EmptyEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveUpdateError(event eventArg: UpdateEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveUpdateProgress(progress progressArg: UpdateProgress, completion: @escaping (Result<Void, FlutterError>) -> Void)
}
class PlatformAidlabUpdateDelegate: PlatformAidlabUpdateDelegateProtocol {
  private let binaryMessenger: FlutterBinaryMessenger
  init(binaryMessenger: FlutterBinaryMessenger) {
    self.binaryMessenger = binaryMessenger
  }
  var codec: FlutterStandardMessageCodec {
    return PlatformAidlabUpdateDelegateCodec.shared
  }
  func didFinishUpdate(nothing nothingArg: EmptyEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabUpdateDelegate.didFinishUpdate"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([nothingArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveUpdateError(event eventArg: UpdateEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabUpdateDelegate.didReceiveUpdateError"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([eventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveUpdateProgress(progress progressArg: UpdateProgress, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabUpdateDelegate.didReceiveUpdateProgress"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([progressArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
}
private class PlatformAidlabCodecReader: FlutterStandardReader {
  override func readValue(ofType type: UInt8) -> Any? {
    switch type {
    case 128:
      return EcgFiltrationRequest.fromList(self.readValue() as! [Any?])
    case 129:
      return FirmwareInfoRequest.fromList(self.readValue() as! [Any?])
    case 130:
      return FirmwareUpdateRequest.fromList(self.readValue() as! [Any?])
    case 131:
      return SendRequest.fromList(self.readValue() as! [Any?])
    default:
      return super.readValue(ofType: type)
    }
  }
}

private class PlatformAidlabCodecWriter: FlutterStandardWriter {
  override func writeValue(_ value: Any) {
    if let value = value as? EcgFiltrationRequest {
      super.writeByte(128)
      super.writeValue(value.toList())
    } else if let value = value as? FirmwareInfoRequest {
      super.writeByte(129)
      super.writeValue(value.toList())
    } else if let value = value as? FirmwareUpdateRequest {
      super.writeByte(130)
      super.writeValue(value.toList())
    } else if let value = value as? SendRequest {
      super.writeByte(131)
      super.writeValue(value.toList())
    } else {
      super.writeValue(value)
    }
  }
}

private class PlatformAidlabCodecReaderWriter: FlutterStandardReaderWriter {
  override func reader(with data: Data) -> FlutterStandardReader {
    return PlatformAidlabCodecReader(data: data)
  }

  override func writer(with data: NSMutableData) -> FlutterStandardWriter {
    return PlatformAidlabCodecWriter(data: data)
  }
}

class PlatformAidlabCodec: FlutterStandardMessageCodec {
  static let shared = PlatformAidlabCodec(readerWriter: PlatformAidlabCodecReaderWriter())
}

/// Generated protocol from Pigeon that represents a handler of messages from Flutter.
protocol PlatformAidlab {
  func disconnect() throws
  func send(sendRequest: SendRequest) throws
  func setECGFiltrationMethod(ecgFiltrationRequest: EcgFiltrationRequest) throws
  func startSynchronization() throws
  func stopSynchronization() throws
  func requestForFirmwareInfo(firmwareInfoRequest: FirmwareInfoRequest) throws
  func startFirmwareUpdate(firmwareUpdateRequest: FirmwareUpdateRequest) throws
}

/// Generated setup class from Pigeon to handle messages through the `binaryMessenger`.
class PlatformAidlabSetup {
  /// The codec used by PlatformAidlab.
  static var codec: FlutterStandardMessageCodec { PlatformAidlabCodec.shared }
  /// Sets up an instance of `PlatformAidlab` to handle messages through the `binaryMessenger`.
  static func setUp(binaryMessenger: FlutterBinaryMessenger, api: PlatformAidlab?) {
    let disconnectChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.aidlab_sdk.PlatformAidlab.disconnect", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      disconnectChannel.setMessageHandler { _, reply in
        do {
          try api.disconnect()
          reply(wrapResult(nil))
        } catch {
          reply(wrapError(error))
        }
      }
    } else {
      disconnectChannel.setMessageHandler(nil)
    }
    let sendChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.aidlab_sdk.PlatformAidlab.send", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      sendChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let sendRequestArg = args[0] as! SendRequest
        do {
          try api.send(sendRequest: sendRequestArg)
          reply(wrapResult(nil))
        } catch {
          reply(wrapError(error))
        }
      }
    } else {
      sendChannel.setMessageHandler(nil)
    }
    let setECGFiltrationMethodChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.aidlab_sdk.PlatformAidlab.setECGFiltrationMethod", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      setECGFiltrationMethodChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let ecgFiltrationRequestArg = args[0] as! EcgFiltrationRequest
        do {
          try api.setECGFiltrationMethod(ecgFiltrationRequest: ecgFiltrationRequestArg)
          reply(wrapResult(nil))
        } catch {
          reply(wrapError(error))
        }
      }
    } else {
      setECGFiltrationMethodChannel.setMessageHandler(nil)
    }
    let startSynchronizationChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.aidlab_sdk.PlatformAidlab.startSynchronization", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      startSynchronizationChannel.setMessageHandler { _, reply in
        do {
          try api.startSynchronization()
          reply(wrapResult(nil))
        } catch {
          reply(wrapError(error))
        }
      }
    } else {
      startSynchronizationChannel.setMessageHandler(nil)
    }
    let stopSynchronizationChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.aidlab_sdk.PlatformAidlab.stopSynchronization", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      stopSynchronizationChannel.setMessageHandler { _, reply in
        do {
          try api.stopSynchronization()
          reply(wrapResult(nil))
        } catch {
          reply(wrapError(error))
        }
      }
    } else {
      stopSynchronizationChannel.setMessageHandler(nil)
    }
    let requestForFirmwareInfoChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.aidlab_sdk.PlatformAidlab.requestForFirmwareInfo", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      requestForFirmwareInfoChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let firmwareInfoRequestArg = args[0] as! FirmwareInfoRequest
        do {
          try api.requestForFirmwareInfo(firmwareInfoRequest: firmwareInfoRequestArg)
          reply(wrapResult(nil))
        } catch {
          reply(wrapError(error))
        }
      }
    } else {
      requestForFirmwareInfoChannel.setMessageHandler(nil)
    }
    let startFirmwareUpdateChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.aidlab_sdk.PlatformAidlab.startFirmwareUpdate", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      startFirmwareUpdateChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let firmwareUpdateRequestArg = args[0] as! FirmwareUpdateRequest
        do {
          try api.startFirmwareUpdate(firmwareUpdateRequest: firmwareUpdateRequestArg)
          reply(wrapResult(nil))
        } catch {
          reply(wrapError(error))
        }
      }
    } else {
      startFirmwareUpdateChannel.setMessageHandler(nil)
    }
  }
}
private class PlatformAidlabSynchronizationDelegateCodecReader: FlutterStandardReader {
  override func readValue(ofType type: UInt8) -> Any? {
    switch type {
    case 128:
      return ActivityEvent.fromList(self.readValue() as! [Any?])
    case 129:
      return BodyPositionEvent.fromList(self.readValue() as! [Any?])
    case 130:
      return EcgEvent.fromList(self.readValue() as! [Any?])
    case 131:
      return HeartRateEvent.fromList(self.readValue() as! [Any?])
    case 132:
      return OrientationEvent.fromList(self.readValue() as! [Any?])
    case 133:
      return PressureEvent.fromList(self.readValue() as! [Any?])
    case 134:
      return QuaternionEvent.fromList(self.readValue() as! [Any?])
    case 135:
      return RespirationEvent.fromList(self.readValue() as! [Any?])
    case 136:
      return RespirationRateEvent.fromList(self.readValue() as! [Any?])
    case 137:
      return RrEvent.fromList(self.readValue() as! [Any?])
    case 138:
      return SignalQualityEvent.fromList(self.readValue() as! [Any?])
    case 139:
      return SkinTemperatureEvent.fromList(self.readValue() as! [Any?])
    case 140:
      return SoundFeaturesEvent.fromList(self.readValue() as! [Any?])
    case 141:
      return SoundVolumeEvent.fromList(self.readValue() as! [Any?])
    case 142:
      return StepsEvent.fromList(self.readValue() as! [Any?])
    case 143:
      return SyncStateEvent.fromList(self.readValue() as! [Any?])
    case 144:
      return UnsynchronizedSizeEvent.fromList(self.readValue() as! [Any?])
    case 145:
      return UserEvent.fromList(self.readValue() as! [Any?])
    case 146:
      return VectorEvent.fromList(self.readValue() as! [Any?])
    default:
      return super.readValue(ofType: type)
    }
  }
}

private class PlatformAidlabSynchronizationDelegateCodecWriter: FlutterStandardWriter {
  override func writeValue(_ value: Any) {
    if let value = value as? ActivityEvent {
      super.writeByte(128)
      super.writeValue(value.toList())
    } else if let value = value as? BodyPositionEvent {
      super.writeByte(129)
      super.writeValue(value.toList())
    } else if let value = value as? EcgEvent {
      super.writeByte(130)
      super.writeValue(value.toList())
    } else if let value = value as? HeartRateEvent {
      super.writeByte(131)
      super.writeValue(value.toList())
    } else if let value = value as? OrientationEvent {
      super.writeByte(132)
      super.writeValue(value.toList())
    } else if let value = value as? PressureEvent {
      super.writeByte(133)
      super.writeValue(value.toList())
    } else if let value = value as? QuaternionEvent {
      super.writeByte(134)
      super.writeValue(value.toList())
    } else if let value = value as? RespirationEvent {
      super.writeByte(135)
      super.writeValue(value.toList())
    } else if let value = value as? RespirationRateEvent {
      super.writeByte(136)
      super.writeValue(value.toList())
    } else if let value = value as? RrEvent {
      super.writeByte(137)
      super.writeValue(value.toList())
    } else if let value = value as? SignalQualityEvent {
      super.writeByte(138)
      super.writeValue(value.toList())
    } else if let value = value as? SkinTemperatureEvent {
      super.writeByte(139)
      super.writeValue(value.toList())
    } else if let value = value as? SoundFeaturesEvent {
      super.writeByte(140)
      super.writeValue(value.toList())
    } else if let value = value as? SoundVolumeEvent {
      super.writeByte(141)
      super.writeValue(value.toList())
    } else if let value = value as? StepsEvent {
      super.writeByte(142)
      super.writeValue(value.toList())
    } else if let value = value as? SyncStateEvent {
      super.writeByte(143)
      super.writeValue(value.toList())
    } else if let value = value as? UnsynchronizedSizeEvent {
      super.writeByte(144)
      super.writeValue(value.toList())
    } else if let value = value as? UserEvent {
      super.writeByte(145)
      super.writeValue(value.toList())
    } else if let value = value as? VectorEvent {
      super.writeByte(146)
      super.writeValue(value.toList())
    } else {
      super.writeValue(value)
    }
  }
}

private class PlatformAidlabSynchronizationDelegateCodecReaderWriter: FlutterStandardReaderWriter {
  override func reader(with data: Data) -> FlutterStandardReader {
    return PlatformAidlabSynchronizationDelegateCodecReader(data: data)
  }

  override func writer(with data: NSMutableData) -> FlutterStandardWriter {
    return PlatformAidlabSynchronizationDelegateCodecWriter(data: data)
  }
}

class PlatformAidlabSynchronizationDelegateCodec: FlutterStandardMessageCodec {
  static let shared = PlatformAidlabSynchronizationDelegateCodec(readerWriter: PlatformAidlabSynchronizationDelegateCodecReaderWriter())
}

/// Generated protocol from Pigeon that represents Flutter messages that can be called from Swift.
protocol PlatformAidlabSynchronizationDelegateProtocol {
  func syncStateDidChange(syncStateEvent syncStateEventArg: SyncStateEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastECG(ecgEvent ecgEventArg: EcgEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastRespiration(respirationEvent respirationEventArg: RespirationEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastSkinTemperature(skinTemperatureEvent skinTemperatureEventArg: SkinTemperatureEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastHeartRate(heartRateEvent heartRateEventArg: HeartRateEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastRr(rrEvent rrEventArg: RrEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveUnsynchronizedSize(unsynchronizedSizeEvent unsynchronizedSizeEventArg: UnsynchronizedSizeEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastRespirationRate(respirationRateEvent respirationRateEventArg: RespirationRateEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastActivity(activityEvent activityEventArg: ActivityEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastSteps(stepsEvent stepsEventArg: StepsEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastSoundVolume(soundVolumeEvent soundVolumeEventArg: SoundVolumeEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastAccelerometer(vectorEvent vectorEventArg: VectorEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastGyroscope(vectorEvent vectorEventArg: VectorEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastMagnetometer(vectorEvent vectorEventArg: VectorEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastQuaternion(quaternionEvent quaternionEventArg: QuaternionEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastOrientation(orientationEvent orientationEventArg: OrientationEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastBodyPosition(bodyPositionEvent bodyPositionEventArg: BodyPositionEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastPressure(pressureEvent pressureEventArg: PressureEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didDetectPastUserEvent(userEvent userEventArg: UserEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastSoundFeatures(soundFeaturesEvent soundFeaturesEventArg: SoundFeaturesEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastSignalQuality(signalQualityEvent signalQualityEventArg: SignalQualityEvent, completion: @escaping (Result<Void, FlutterError>) -> Void)
}
class PlatformAidlabSynchronizationDelegate: PlatformAidlabSynchronizationDelegateProtocol {
  private let binaryMessenger: FlutterBinaryMessenger
  init(binaryMessenger: FlutterBinaryMessenger) {
    self.binaryMessenger = binaryMessenger
  }
  var codec: FlutterStandardMessageCodec {
    return PlatformAidlabSynchronizationDelegateCodec.shared
  }
  func syncStateDidChange(syncStateEvent syncStateEventArg: SyncStateEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.syncStateDidChange"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([syncStateEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastECG(ecgEvent ecgEventArg: EcgEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastECG"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([ecgEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastRespiration(respirationEvent respirationEventArg: RespirationEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastRespiration"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([respirationEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastSkinTemperature(skinTemperatureEvent skinTemperatureEventArg: SkinTemperatureEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSkinTemperature"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([skinTemperatureEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastHeartRate(heartRateEvent heartRateEventArg: HeartRateEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastHeartRate"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([heartRateEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastRr(rrEvent rrEventArg: RrEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastRr"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([rrEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveUnsynchronizedSize(unsynchronizedSizeEvent unsynchronizedSizeEventArg: UnsynchronizedSizeEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceiveUnsynchronizedSize"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([unsynchronizedSizeEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastRespirationRate(respirationRateEvent respirationRateEventArg: RespirationRateEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastRespirationRate"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([respirationRateEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastActivity(activityEvent activityEventArg: ActivityEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastActivity"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([activityEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastSteps(stepsEvent stepsEventArg: StepsEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSteps"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([stepsEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastSoundVolume(soundVolumeEvent soundVolumeEventArg: SoundVolumeEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSoundVolume"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([soundVolumeEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastAccelerometer(vectorEvent vectorEventArg: VectorEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastAccelerometer"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([vectorEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastGyroscope(vectorEvent vectorEventArg: VectorEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastGyroscope"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([vectorEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastMagnetometer(vectorEvent vectorEventArg: VectorEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastMagnetometer"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([vectorEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastQuaternion(quaternionEvent quaternionEventArg: QuaternionEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastQuaternion"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([quaternionEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastOrientation(orientationEvent orientationEventArg: OrientationEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastOrientation"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([orientationEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastBodyPosition(bodyPositionEvent bodyPositionEventArg: BodyPositionEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastBodyPosition"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([bodyPositionEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastPressure(pressureEvent pressureEventArg: PressureEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastPressure"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([pressureEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didDetectPastUserEvent(userEvent userEventArg: UserEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didDetectPastUserEvent"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([userEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastSoundFeatures(soundFeaturesEvent soundFeaturesEventArg: SoundFeaturesEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSoundFeatures"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([soundFeaturesEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastSignalQuality(signalQualityEvent signalQualityEventArg: SignalQualityEvent, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSignalQuality"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([signalQualityEventArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
}
