// Autogenerated from Pigeon (v17.0.0), do not edit directly.
// See also: https://pub.dev/packages/pigeon
// ignore_for_file: public_member_api_docs, non_constant_identifier_names, avoid_as, unused_import, unnecessary_parenthesis, prefer_null_aware_operators, omit_local_variable_types, unused_shown_name, unnecessary_import, no_leading_underscores_for_local_identifiers

import 'dart:async';
import 'dart:typed_data' show Float64List, Int32List, Int64List, Uint8List;

import 'package:flutter/foundation.dart' show ReadBuffer, WriteBuffer;
import 'package:flutter/services.dart';

PlatformException _createConnectionError(String channelName) {
  return PlatformException(
    code: 'channel-error',
    message: 'Unable to establish connection on channel: "$channelName".',
  );
}

List<Object?> wrapResponse(
    {Object? result, PlatformException? error, bool empty = false}) {
  if (empty) {
    return <Object?>[];
  }
  if (error == null) {
    return <Object?>[result];
  }
  return <Object?>[error.code, error.message, error.details];
}

class ScanModeRequest {
  ScanModeRequest({
    this.mode,
  });

  int? mode;

  Object encode() {
    return <Object?>[
      mode,
    ];
  }

  static ScanModeRequest decode(Object result) {
    result as List<Object?>;
    return ScanModeRequest(
      mode: result[0] as int?,
    );
  }
}

class ConnectRequest {
  ConnectRequest({
    this.address,
    this.signals,
  });

  String? address;

  Int32List? signals;

  Object encode() {
    return <Object?>[
      address,
      signals,
    ];
  }

  static ConnectRequest decode(Object result) {
    result as List<Object?>;
    return ConnectRequest(
      address: result[0] as String?,
      signals: result[1] as Int32List?,
    );
  }
}

class AidlabDetectedEvent {
  AidlabDetectedEvent({
    this.address,
    this.rssi,
  });

  String? address;

  int? rssi;

  Object encode() {
    return <Object?>[
      address,
      rssi,
    ];
  }

  static AidlabDetectedEvent decode(Object result) {
    result as List<Object?>;
    return AidlabDetectedEvent(
      address: result[0] as String?,
      rssi: result[1] as int?,
    );
  }
}

class ScanFailedEvent {
  ScanFailedEvent({
    this.errorCode,
  });

  int? errorCode;

  Object encode() {
    return <Object?>[
      errorCode,
    ];
  }

  static ScanFailedEvent decode(Object result) {
    result as List<Object?>;
    return ScanFailedEvent(
      errorCode: result[0] as int?,
    );
  }
}

class LogEvent {
  LogEvent({
    this.msg,
  });

  String? msg;

  Object encode() {
    return <Object?>[
      msg,
    ];
  }

  static LogEvent decode(Object result) {
    result as List<Object?>;
    return LogEvent(
      msg: result[0] as String?,
    );
  }
}

class ConnectEvent {
  ConnectEvent({
    required this.firmwareRevision,
    required this.hardwareRevision,
    required this.serialNumber,
    required this.address,
  });

  String firmwareRevision;

  String hardwareRevision;

  String serialNumber;

  String address;

  Object encode() {
    return <Object?>[
      firmwareRevision,
      hardwareRevision,
      serialNumber,
      address,
    ];
  }

  static ConnectEvent decode(Object result) {
    result as List<Object?>;
    return ConnectEvent(
      firmwareRevision: result[0]! as String,
      hardwareRevision: result[1]! as String,
      serialNumber: result[2]! as String,
      address: result[3]! as String,
    );
  }
}

class EcgEvent {
  EcgEvent({
    required this.timestamp,
    required this.values,
  });

  int timestamp;

  Float64List values;

  Object encode() {
    return <Object?>[
      timestamp,
      values,
    ];
  }

  static EcgEvent decode(Object result) {
    result as List<Object?>;
    return EcgEvent(
      timestamp: result[0]! as int,
      values: result[1]! as Float64List,
    );
  }
}

class RespirationEvent {
  RespirationEvent({
    required this.timestamp,
    required this.values,
  });

  int timestamp;

  Float64List values;

  Object encode() {
    return <Object?>[
      timestamp,
      values,
    ];
  }

  static RespirationEvent decode(Object result) {
    result as List<Object?>;
    return RespirationEvent(
      timestamp: result[0]! as int,
      values: result[1]! as Float64List,
    );
  }
}

class RespirationRateEvent {
  RespirationRateEvent({
    required this.timestamp,
    required this.value,
  });

  int timestamp;

  int value;

  Object encode() {
    return <Object?>[
      timestamp,
      value,
    ];
  }

  static RespirationRateEvent decode(Object result) {
    result as List<Object?>;
    return RespirationRateEvent(
      timestamp: result[0]! as int,
      value: result[1]! as int,
    );
  }
}

class BatteryLevelEvent {
  BatteryLevelEvent({
    required this.stateOfCharge,
  });

  int stateOfCharge;

  Object encode() {
    return <Object?>[
      stateOfCharge,
    ];
  }

  static BatteryLevelEvent decode(Object result) {
    result as List<Object?>;
    return BatteryLevelEvent(
      stateOfCharge: result[0]! as int,
    );
  }
}

class VectorEvent {
  VectorEvent({
    required this.timestamp,
    required this.x,
    required this.y,
    required this.z,
  });

  int timestamp;

  double x;

  double y;

  double z;

  Object encode() {
    return <Object?>[
      timestamp,
      x,
      y,
      z,
    ];
  }

  static VectorEvent decode(Object result) {
    result as List<Object?>;
    return VectorEvent(
      timestamp: result[0]! as int,
      x: result[1]! as double,
      y: result[2]! as double,
      z: result[3]! as double,
    );
  }
}

class QuaternionEvent {
  QuaternionEvent({
    required this.timestamp,
    required this.qw,
    required this.qx,
    required this.qy,
    required this.qz,
  });

  int timestamp;

  double qw;

  double qx;

  double qy;

  double qz;

  Object encode() {
    return <Object?>[
      timestamp,
      qw,
      qx,
      qy,
      qz,
    ];
  }

  static QuaternionEvent decode(Object result) {
    result as List<Object?>;
    return QuaternionEvent(
      timestamp: result[0]! as int,
      qw: result[1]! as double,
      qx: result[2]! as double,
      qy: result[3]! as double,
      qz: result[4]! as double,
    );
  }
}

class OrientationEvent {
  OrientationEvent({
    required this.timestamp,
    required this.roll,
    required this.pitch,
    required this.yaw,
  });

  int timestamp;

  double roll;

  double pitch;

  double yaw;

  Object encode() {
    return <Object?>[
      timestamp,
      roll,
      pitch,
      yaw,
    ];
  }

  static OrientationEvent decode(Object result) {
    result as List<Object?>;
    return OrientationEvent(
      timestamp: result[0]! as int,
      roll: result[1]! as double,
      pitch: result[2]! as double,
      yaw: result[3]! as double,
    );
  }
}

class BodyPositionEvent {
  BodyPositionEvent({
    required this.timestamp,
    required this.bodyPosition,
  });

  int timestamp;

  int bodyPosition;

  Object encode() {
    return <Object?>[
      timestamp,
      bodyPosition,
    ];
  }

  static BodyPositionEvent decode(Object result) {
    result as List<Object?>;
    return BodyPositionEvent(
      timestamp: result[0]! as int,
      bodyPosition: result[1]! as int,
    );
  }
}

class ActivityEvent {
  ActivityEvent({
    required this.timestamp,
    required this.activityType,
  });

  int timestamp;

  int activityType;

  Object encode() {
    return <Object?>[
      timestamp,
      activityType,
    ];
  }

  static ActivityEvent decode(Object result) {
    result as List<Object?>;
    return ActivityEvent(
      timestamp: result[0]! as int,
      activityType: result[1]! as int,
    );
  }
}

class StepsEvent {
  StepsEvent({
    required this.timestamp,
    required this.value,
  });

  int timestamp;

  int value;

  Object encode() {
    return <Object?>[
      timestamp,
      value,
    ];
  }

  static StepsEvent decode(Object result) {
    result as List<Object?>;
    return StepsEvent(
      timestamp: result[0]! as int,
      value: result[1]! as int,
    );
  }
}

class HeartRateEvent {
  HeartRateEvent({
    required this.timestamp,
    required this.heartRate,
  });

  int timestamp;

  int heartRate;

  Object encode() {
    return <Object?>[
      timestamp,
      heartRate,
    ];
  }

  static HeartRateEvent decode(Object result) {
    result as List<Object?>;
    return HeartRateEvent(
      timestamp: result[0]! as int,
      heartRate: result[1]! as int,
    );
  }
}

class RrEvent {
  RrEvent({
    required this.timestamp,
    required this.rr,
  });

  int timestamp;

  int rr;

  Object encode() {
    return <Object?>[
      timestamp,
      rr,
    ];
  }

  static RrEvent decode(Object result) {
    result as List<Object?>;
    return RrEvent(
      timestamp: result[0]! as int,
      rr: result[1]! as int,
    );
  }
}

class WearStateEvent {
  WearStateEvent({
    required this.wearState,
  });

  int wearState;

  Object encode() {
    return <Object?>[
      wearState,
    ];
  }

  static WearStateEvent decode(Object result) {
    result as List<Object?>;
    return WearStateEvent(
      wearState: result[0]! as int,
    );
  }
}

class SkinTemperatureEvent {
  SkinTemperatureEvent({
    required this.timestamp,
    required this.value,
  });

  int timestamp;

  double value;

  Object encode() {
    return <Object?>[
      timestamp,
      value,
    ];
  }

  static SkinTemperatureEvent decode(Object result) {
    result as List<Object?>;
    return SkinTemperatureEvent(
      timestamp: result[0]! as int,
      value: result[1]! as double,
    );
  }
}

class ExerciseEvent {
  ExerciseEvent({
    this.exercise,
  });

  int? exercise;

  Object encode() {
    return <Object?>[
      exercise,
    ];
  }

  static ExerciseEvent decode(Object result) {
    result as List<Object?>;
    return ExerciseEvent(
      exercise: result[0] as int?,
    );
  }
}

class SoundVolumeEvent {
  SoundVolumeEvent({
    required this.timestamp,
    required this.soundVolume,
  });

  int timestamp;

  int soundVolume;

  Object encode() {
    return <Object?>[
      timestamp,
      soundVolume,
    ];
  }

  static SoundVolumeEvent decode(Object result) {
    result as List<Object?>;
    return SoundVolumeEvent(
      timestamp: result[0]! as int,
      soundVolume: result[1]! as int,
    );
  }
}

class ErrorEvent {
  ErrorEvent({
    required this.error,
  });

  String error;

  Object encode() {
    return <Object?>[
      error,
    ];
  }

  static ErrorEvent decode(Object result) {
    result as List<Object?>;
    return ErrorEvent(
      error: result[0]! as String,
    );
  }
}

class MessageEvent {
  MessageEvent({
    required this.process,
    required this.message,
  });

  String process;

  String message;

  Object encode() {
    return <Object?>[
      process,
      message,
    ];
  }

  static MessageEvent decode(Object result) {
    result as List<Object?>;
    return MessageEvent(
      process: result[0]! as String,
      message: result[1]! as String,
    );
  }
}

class UserEvent {
  UserEvent({
    required this.timestamp,
  });

  int timestamp;

  Object encode() {
    return <Object?>[
      timestamp,
    ];
  }

  static UserEvent decode(Object result) {
    result as List<Object?>;
    return UserEvent(
      timestamp: result[0]! as int,
    );
  }
}

class SoundFeaturesEvent {
  SoundFeaturesEvent({
    required this.values,
  });

  Float64List values;

  Object encode() {
    return <Object?>[
      values,
    ];
  }

  static SoundFeaturesEvent decode(Object result) {
    result as List<Object?>;
    return SoundFeaturesEvent(
      values: result[0]! as Float64List,
    );
  }
}

class DisconnectEvent {
  DisconnectEvent({
    required this.disconnectReason,
  });

  int disconnectReason;

  Object encode() {
    return <Object?>[
      disconnectReason,
    ];
  }

  static DisconnectEvent decode(Object result) {
    result as List<Object?>;
    return DisconnectEvent(
      disconnectReason: result[0]! as int,
    );
  }
}

class SignalQualityEvent {
  SignalQualityEvent({
    required this.timestamp,
    required this.value,
  });

  int timestamp;

  int value;

  Object encode() {
    return <Object?>[
      timestamp,
      value,
    ];
  }

  static SignalQualityEvent decode(Object result) {
    result as List<Object?>;
    return SignalQualityEvent(
      timestamp: result[0]! as int,
      value: result[1]! as int,
    );
  }
}

class FirmwareInformationEvent {
  FirmwareInformationEvent({
    this.updateAvailable,
    this.updatableVersion,
  });

  bool? updateAvailable;

  String? updatableVersion;

  Object encode() {
    return <Object?>[
      updateAvailable,
      updatableVersion,
    ];
  }

  static FirmwareInformationEvent decode(Object result) {
    result as List<Object?>;
    return FirmwareInformationEvent(
      updateAvailable: result[0] as bool?,
      updatableVersion: result[1] as String?,
    );
  }
}

class PressureEvent {
  PressureEvent({
    this.timestamp,
    this.values,
  });

  int? timestamp;

  Int32List? values;

  Object encode() {
    return <Object?>[
      timestamp,
      values,
    ];
  }

  static PressureEvent decode(Object result) {
    result as List<Object?>;
    return PressureEvent(
      timestamp: result[0] as int?,
      values: result[1] as Int32List?,
    );
  }
}

class PressureWearStateEvent {
  PressureWearStateEvent({
    this.wearState,
  });

  int? wearState;

  Object encode() {
    return <Object?>[
      wearState,
    ];
  }

  static PressureWearStateEvent decode(Object result) {
    result as List<Object?>;
    return PressureWearStateEvent(
      wearState: result[0] as int?,
    );
  }
}

class UpdateProgress {
  UpdateProgress({
    this.progress,
  });

  int? progress;

  Object encode() {
    return <Object?>[
      progress,
    ];
  }

  static UpdateProgress decode(Object result) {
    result as List<Object?>;
    return UpdateProgress(
      progress: result[0] as int?,
    );
  }
}

class UpdateEvent {
  UpdateEvent({
    this.error,
  });

  int? error;

  Object encode() {
    return <Object?>[
      error,
    ];
  }

  static UpdateEvent decode(Object result) {
    result as List<Object?>;
    return UpdateEvent(
      error: result[0] as int?,
    );
  }
}

class SendRequest {
  SendRequest({
    required this.command,
  });

  String command;

  Object encode() {
    return <Object?>[
      command,
    ];
  }

  static SendRequest decode(Object result) {
    result as List<Object?>;
    return SendRequest(
      command: result[0]! as String,
    );
  }
}

class EcgFiltrationRequest {
  EcgFiltrationRequest({
    required this.method,
  });

  int method;

  Object encode() {
    return <Object?>[
      method,
    ];
  }

  static EcgFiltrationRequest decode(Object result) {
    result as List<Object?>;
    return EcgFiltrationRequest(
      method: result[0]! as int,
    );
  }
}

class FirmwareInfoRequest {
  FirmwareInfoRequest({
    required this.url,
  });

  String url;

  Object encode() {
    return <Object?>[
      url,
    ];
  }

  static FirmwareInfoRequest decode(Object result) {
    result as List<Object?>;
    return FirmwareInfoRequest(
      url: result[0]! as String,
    );
  }
}

class FirmwareUpdateRequest {
  FirmwareUpdateRequest({
    required this.url,
    required this.updatableVersion,
  });

  String url;

  String updatableVersion;

  Object encode() {
    return <Object?>[
      url,
      updatableVersion,
    ];
  }

  static FirmwareUpdateRequest decode(Object result) {
    result as List<Object?>;
    return FirmwareUpdateRequest(
      url: result[0]! as String,
      updatableVersion: result[1]! as String,
    );
  }
}

class SyncStateEvent {
  SyncStateEvent({
    required this.state,
  });

  int state;

  Object encode() {
    return <Object?>[
      state,
    ];
  }

  static SyncStateEvent decode(Object result) {
    result as List<Object?>;
    return SyncStateEvent(
      state: result[0]! as int,
    );
  }
}

class UnsynchronizedSizeEvent {
  UnsynchronizedSizeEvent({
    required this.unsynchronizedSize,
    required this.syncBytesPerSecond,
  });

  int unsynchronizedSize;

  double syncBytesPerSecond;

  Object encode() {
    return <Object?>[
      unsynchronizedSize,
      syncBytesPerSecond,
    ];
  }

  static UnsynchronizedSizeEvent decode(Object result) {
    result as List<Object?>;
    return UnsynchronizedSizeEvent(
      unsynchronizedSize: result[0]! as int,
      syncBytesPerSecond: result[1]! as double,
    );
  }
}

class EmptyEvent {
  EmptyEvent({
    required this.nothing,
  });

  int nothing;

  Object encode() {
    return <Object?>[
      nothing,
    ];
  }

  static EmptyEvent decode(Object result) {
    result as List<Object?>;
    return EmptyEvent(
      nothing: result[0]! as int,
    );
  }
}

class _PlatformAidlabSdkCodec extends StandardMessageCodec {
  const _PlatformAidlabSdkCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is ConnectRequest) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else if (value is ScanModeRequest) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return ConnectRequest.decode(readValue(buffer)!);
      case 129:
        return ScanModeRequest.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}

class PlatformAidlabSdk {
  /// Constructor for [PlatformAidlabSdk].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  PlatformAidlabSdk({BinaryMessenger? binaryMessenger})
      : __pigeon_binaryMessenger = binaryMessenger;
  final BinaryMessenger? __pigeon_binaryMessenger;

  static const MessageCodec<Object?> pigeonChannelCodec =
      _PlatformAidlabSdkCodec();

  Future<void> initSdk() async {
    const String __pigeon_channelName =
        'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdk.initSdk';
    final BasicMessageChannel<Object?> __pigeon_channel =
        BasicMessageChannel<Object?>(
      __pigeon_channelName,
      pigeonChannelCodec,
      binaryMessenger: __pigeon_binaryMessenger,
    );
    final List<Object?>? __pigeon_replyList =
        await __pigeon_channel.send(null) as List<Object?>?;
    if (__pigeon_replyList == null) {
      throw _createConnectionError(__pigeon_channelName);
    } else if (__pigeon_replyList.length > 1) {
      throw PlatformException(
        code: __pigeon_replyList[0]! as String,
        message: __pigeon_replyList[1] as String?,
        details: __pigeon_replyList[2],
      );
    } else {
      return;
    }
  }

  Future<void> scanForDevices(ScanModeRequest scanMode) async {
    const String __pigeon_channelName =
        'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdk.scanForDevices';
    final BasicMessageChannel<Object?> __pigeon_channel =
        BasicMessageChannel<Object?>(
      __pigeon_channelName,
      pigeonChannelCodec,
      binaryMessenger: __pigeon_binaryMessenger,
    );
    final List<Object?>? __pigeon_replyList =
        await __pigeon_channel.send(<Object?>[scanMode]) as List<Object?>?;
    if (__pigeon_replyList == null) {
      throw _createConnectionError(__pigeon_channelName);
    } else if (__pigeon_replyList.length > 1) {
      throw PlatformException(
        code: __pigeon_replyList[0]! as String,
        message: __pigeon_replyList[1] as String?,
        details: __pigeon_replyList[2],
      );
    } else {
      return;
    }
  }

  Future<void> stopDeviceScan() async {
    const String __pigeon_channelName =
        'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdk.stopDeviceScan';
    final BasicMessageChannel<Object?> __pigeon_channel =
        BasicMessageChannel<Object?>(
      __pigeon_channelName,
      pigeonChannelCodec,
      binaryMessenger: __pigeon_binaryMessenger,
    );
    final List<Object?>? __pigeon_replyList =
        await __pigeon_channel.send(null) as List<Object?>?;
    if (__pigeon_replyList == null) {
      throw _createConnectionError(__pigeon_channelName);
    } else if (__pigeon_replyList.length > 1) {
      throw PlatformException(
        code: __pigeon_replyList[0]! as String,
        message: __pigeon_replyList[1] as String?,
        details: __pigeon_replyList[2],
      );
    } else {
      return;
    }
  }

  Future<void> connect(ConnectRequest request) async {
    const String __pigeon_channelName =
        'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdk.connect';
    final BasicMessageChannel<Object?> __pigeon_channel =
        BasicMessageChannel<Object?>(
      __pigeon_channelName,
      pigeonChannelCodec,
      binaryMessenger: __pigeon_binaryMessenger,
    );
    final List<Object?>? __pigeon_replyList =
        await __pigeon_channel.send(<Object?>[request]) as List<Object?>?;
    if (__pigeon_replyList == null) {
      throw _createConnectionError(__pigeon_channelName);
    } else if (__pigeon_replyList.length > 1) {
      throw PlatformException(
        code: __pigeon_replyList[0]! as String,
        message: __pigeon_replyList[1] as String?,
        details: __pigeon_replyList[2],
      );
    } else {
      return;
    }
  }
}

class _PlatformAidlabSdkDelegateCodec extends StandardMessageCodec {
  const _PlatformAidlabSdkDelegateCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is AidlabDetectedEvent) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else if (value is EmptyEvent) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else if (value is ScanFailedEvent) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return AidlabDetectedEvent.decode(readValue(buffer)!);
      case 129:
        return EmptyEvent.decode(readValue(buffer)!);
      case 130:
        return ScanFailedEvent.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}

abstract class PlatformAidlabSdkDelegate {
  static const MessageCodec<Object?> pigeonChannelCodec =
      _PlatformAidlabSdkDelegateCodec();

  void onBluetoothStarted(EmptyEvent voidEvent);

  void onDeviceScanStarted(EmptyEvent voidEvent);

  void onDeviceScanStopped(EmptyEvent voidEvent);

  void onScanFailed(ScanFailedEvent event);

  void onAidlabDetected(AidlabDetectedEvent event);

  static void setup(PlatformAidlabSdkDelegate? api,
      {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onBluetoothStarted',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onBluetoothStarted was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final EmptyEvent? arg_voidEvent = (args[0] as EmptyEvent?);
          assert(arg_voidEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onBluetoothStarted was null, expected non-null EmptyEvent.');
          try {
            api.onBluetoothStarted(arg_voidEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onDeviceScanStarted',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onDeviceScanStarted was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final EmptyEvent? arg_voidEvent = (args[0] as EmptyEvent?);
          assert(arg_voidEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onDeviceScanStarted was null, expected non-null EmptyEvent.');
          try {
            api.onDeviceScanStarted(arg_voidEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onDeviceScanStopped',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onDeviceScanStopped was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final EmptyEvent? arg_voidEvent = (args[0] as EmptyEvent?);
          assert(arg_voidEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onDeviceScanStopped was null, expected non-null EmptyEvent.');
          try {
            api.onDeviceScanStopped(arg_voidEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onScanFailed',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onScanFailed was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final ScanFailedEvent? arg_event = (args[0] as ScanFailedEvent?);
          assert(arg_event != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onScanFailed was null, expected non-null ScanFailedEvent.');
          try {
            api.onScanFailed(arg_event!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onAidlabDetected',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onAidlabDetected was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final AidlabDetectedEvent? arg_event =
              (args[0] as AidlabDetectedEvent?);
          assert(arg_event != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSdkDelegate.onAidlabDetected was null, expected non-null AidlabDetectedEvent.');
          try {
            api.onAidlabDetected(arg_event!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
  }
}

class _PlatformAidlabLoggerCodec extends StandardMessageCodec {
  const _PlatformAidlabLoggerCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is LogEvent) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return LogEvent.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}

abstract class PlatformAidlabLogger {
  static const MessageCodec<Object?> pigeonChannelCodec =
      _PlatformAidlabLoggerCodec();

  void onLog(LogEvent event);

  void onWarning(LogEvent event);

  void onError(LogEvent event);

  static void setup(PlatformAidlabLogger? api,
      {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> __pigeon_channel =
          BasicMessageChannel<Object?>(
              'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabLogger.onLog',
              pigeonChannelCodec,
              binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabLogger.onLog was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final LogEvent? arg_event = (args[0] as LogEvent?);
          assert(arg_event != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabLogger.onLog was null, expected non-null LogEvent.');
          try {
            api.onLog(arg_event!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel =
          BasicMessageChannel<Object?>(
              'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabLogger.onWarning',
              pigeonChannelCodec,
              binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabLogger.onWarning was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final LogEvent? arg_event = (args[0] as LogEvent?);
          assert(arg_event != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabLogger.onWarning was null, expected non-null LogEvent.');
          try {
            api.onWarning(arg_event!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel =
          BasicMessageChannel<Object?>(
              'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabLogger.onError',
              pigeonChannelCodec,
              binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabLogger.onError was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final LogEvent? arg_event = (args[0] as LogEvent?);
          assert(arg_event != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabLogger.onError was null, expected non-null LogEvent.');
          try {
            api.onError(arg_event!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
  }
}

class _PlatformAidlabDelegateCodec extends StandardMessageCodec {
  const _PlatformAidlabDelegateCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is ActivityEvent) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else if (value is BatteryLevelEvent) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else if (value is BodyPositionEvent) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else if (value is ConnectEvent) {
      buffer.putUint8(131);
      writeValue(buffer, value.encode());
    } else if (value is DisconnectEvent) {
      buffer.putUint8(132);
      writeValue(buffer, value.encode());
    } else if (value is EcgEvent) {
      buffer.putUint8(133);
      writeValue(buffer, value.encode());
    } else if (value is EmptyEvent) {
      buffer.putUint8(134);
      writeValue(buffer, value.encode());
    } else if (value is ErrorEvent) {
      buffer.putUint8(135);
      writeValue(buffer, value.encode());
    } else if (value is ExerciseEvent) {
      buffer.putUint8(136);
      writeValue(buffer, value.encode());
    } else if (value is HeartRateEvent) {
      buffer.putUint8(137);
      writeValue(buffer, value.encode());
    } else if (value is MessageEvent) {
      buffer.putUint8(138);
      writeValue(buffer, value.encode());
    } else if (value is OrientationEvent) {
      buffer.putUint8(139);
      writeValue(buffer, value.encode());
    } else if (value is QuaternionEvent) {
      buffer.putUint8(140);
      writeValue(buffer, value.encode());
    } else if (value is RespirationEvent) {
      buffer.putUint8(141);
      writeValue(buffer, value.encode());
    } else if (value is RespirationRateEvent) {
      buffer.putUint8(142);
      writeValue(buffer, value.encode());
    } else if (value is RrEvent) {
      buffer.putUint8(143);
      writeValue(buffer, value.encode());
    } else if (value is SignalQualityEvent) {
      buffer.putUint8(144);
      writeValue(buffer, value.encode());
    } else if (value is SkinTemperatureEvent) {
      buffer.putUint8(145);
      writeValue(buffer, value.encode());
    } else if (value is SoundFeaturesEvent) {
      buffer.putUint8(146);
      writeValue(buffer, value.encode());
    } else if (value is SoundVolumeEvent) {
      buffer.putUint8(147);
      writeValue(buffer, value.encode());
    } else if (value is StepsEvent) {
      buffer.putUint8(148);
      writeValue(buffer, value.encode());
    } else if (value is UserEvent) {
      buffer.putUint8(149);
      writeValue(buffer, value.encode());
    } else if (value is VectorEvent) {
      buffer.putUint8(150);
      writeValue(buffer, value.encode());
    } else if (value is WearStateEvent) {
      buffer.putUint8(151);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return ActivityEvent.decode(readValue(buffer)!);
      case 129:
        return BatteryLevelEvent.decode(readValue(buffer)!);
      case 130:
        return BodyPositionEvent.decode(readValue(buffer)!);
      case 131:
        return ConnectEvent.decode(readValue(buffer)!);
      case 132:
        return DisconnectEvent.decode(readValue(buffer)!);
      case 133:
        return EcgEvent.decode(readValue(buffer)!);
      case 134:
        return EmptyEvent.decode(readValue(buffer)!);
      case 135:
        return ErrorEvent.decode(readValue(buffer)!);
      case 136:
        return ExerciseEvent.decode(readValue(buffer)!);
      case 137:
        return HeartRateEvent.decode(readValue(buffer)!);
      case 138:
        return MessageEvent.decode(readValue(buffer)!);
      case 139:
        return OrientationEvent.decode(readValue(buffer)!);
      case 140:
        return QuaternionEvent.decode(readValue(buffer)!);
      case 141:
        return RespirationEvent.decode(readValue(buffer)!);
      case 142:
        return RespirationRateEvent.decode(readValue(buffer)!);
      case 143:
        return RrEvent.decode(readValue(buffer)!);
      case 144:
        return SignalQualityEvent.decode(readValue(buffer)!);
      case 145:
        return SkinTemperatureEvent.decode(readValue(buffer)!);
      case 146:
        return SoundFeaturesEvent.decode(readValue(buffer)!);
      case 147:
        return SoundVolumeEvent.decode(readValue(buffer)!);
      case 148:
        return StepsEvent.decode(readValue(buffer)!);
      case 149:
        return UserEvent.decode(readValue(buffer)!);
      case 150:
        return VectorEvent.decode(readValue(buffer)!);
      case 151:
        return WearStateEvent.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}

abstract class PlatformAidlabDelegate {
  static const MessageCodec<Object?> pigeonChannelCodec =
      _PlatformAidlabDelegateCodec();

  void didConnect(ConnectEvent connectEvent);

  void didDisconnect(DisconnectEvent voidEvent);

  void didReceiveEcg(EcgEvent ecgEvent);

  void didReceiveRespiration(RespirationEvent respirationEvent);

  void didReceiveRespirationRate(RespirationRateEvent respirationRateEvent);

  void didReceiveBatteryLevel(BatteryLevelEvent batteryLevelEvent);

  void didReceiveSkinTemperature(SkinTemperatureEvent skinTemperatureEvent);

  void didReceiveAccelerometer(VectorEvent vectorEvent);

  void didReceiveGyroscope(VectorEvent vectorEvent);

  void didReceiveMagnetometer(VectorEvent vectorEvent);

  void didReceiveQuaternion(QuaternionEvent quaternionEvent);

  void didReceiveOrientation(OrientationEvent orientationEvent);

  void didReceiveBodyPosition(BodyPositionEvent bodyPositionEvent);

  void didReceiveActivity(ActivityEvent activityEvent);

  void didReceiveSteps(StepsEvent stepsEvent);

  void didReceiveHeartRate(HeartRateEvent heartRateEvent);

  void didReceiveRr(RrEvent rrEvent);

  void wearStateDidChange(WearStateEvent wearStateEvent);

  void didDetectExercise(ExerciseEvent exerciseEvent);

  void didReceiveSoundVolume(SoundVolumeEvent soundVolumeEvent);

  void didReceiveCommand(EmptyEvent voidEvent);

  void didReceiveError(ErrorEvent errorEvent);

  void didReceiveMessage(MessageEvent messageEvent);

  void didDetectUserEvent(UserEvent userEvent);

  void didReceiveSoundFeatures(SoundFeaturesEvent soundFeaturesEvent);

  void didReceiveSignalQuality(SignalQualityEvent signalQualityEvent);

  static void setup(PlatformAidlabDelegate? api,
      {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> __pigeon_channel =
          BasicMessageChannel<Object?>(
              'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didConnect',
              pigeonChannelCodec,
              binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didConnect was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final ConnectEvent? arg_connectEvent = (args[0] as ConnectEvent?);
          assert(arg_connectEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didConnect was null, expected non-null ConnectEvent.');
          try {
            api.didConnect(arg_connectEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didDisconnect',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didDisconnect was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final DisconnectEvent? arg_voidEvent = (args[0] as DisconnectEvent?);
          assert(arg_voidEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didDisconnect was null, expected non-null DisconnectEvent.');
          try {
            api.didDisconnect(arg_voidEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveEcg',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveEcg was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final EcgEvent? arg_ecgEvent = (args[0] as EcgEvent?);
          assert(arg_ecgEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveEcg was null, expected non-null EcgEvent.');
          try {
            api.didReceiveEcg(arg_ecgEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveRespiration',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveRespiration was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final RespirationEvent? arg_respirationEvent =
              (args[0] as RespirationEvent?);
          assert(arg_respirationEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveRespiration was null, expected non-null RespirationEvent.');
          try {
            api.didReceiveRespiration(arg_respirationEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveRespirationRate',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveRespirationRate was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final RespirationRateEvent? arg_respirationRateEvent =
              (args[0] as RespirationRateEvent?);
          assert(arg_respirationRateEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveRespirationRate was null, expected non-null RespirationRateEvent.');
          try {
            api.didReceiveRespirationRate(arg_respirationRateEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveBatteryLevel',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveBatteryLevel was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final BatteryLevelEvent? arg_batteryLevelEvent =
              (args[0] as BatteryLevelEvent?);
          assert(arg_batteryLevelEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveBatteryLevel was null, expected non-null BatteryLevelEvent.');
          try {
            api.didReceiveBatteryLevel(arg_batteryLevelEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSkinTemperature',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSkinTemperature was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final SkinTemperatureEvent? arg_skinTemperatureEvent =
              (args[0] as SkinTemperatureEvent?);
          assert(arg_skinTemperatureEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSkinTemperature was null, expected non-null SkinTemperatureEvent.');
          try {
            api.didReceiveSkinTemperature(arg_skinTemperatureEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveAccelerometer',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveAccelerometer was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final VectorEvent? arg_vectorEvent = (args[0] as VectorEvent?);
          assert(arg_vectorEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveAccelerometer was null, expected non-null VectorEvent.');
          try {
            api.didReceiveAccelerometer(arg_vectorEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveGyroscope',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveGyroscope was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final VectorEvent? arg_vectorEvent = (args[0] as VectorEvent?);
          assert(arg_vectorEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveGyroscope was null, expected non-null VectorEvent.');
          try {
            api.didReceiveGyroscope(arg_vectorEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveMagnetometer',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveMagnetometer was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final VectorEvent? arg_vectorEvent = (args[0] as VectorEvent?);
          assert(arg_vectorEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveMagnetometer was null, expected non-null VectorEvent.');
          try {
            api.didReceiveMagnetometer(arg_vectorEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveQuaternion',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveQuaternion was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final QuaternionEvent? arg_quaternionEvent =
              (args[0] as QuaternionEvent?);
          assert(arg_quaternionEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveQuaternion was null, expected non-null QuaternionEvent.');
          try {
            api.didReceiveQuaternion(arg_quaternionEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveOrientation',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveOrientation was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final OrientationEvent? arg_orientationEvent =
              (args[0] as OrientationEvent?);
          assert(arg_orientationEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveOrientation was null, expected non-null OrientationEvent.');
          try {
            api.didReceiveOrientation(arg_orientationEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveBodyPosition',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveBodyPosition was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final BodyPositionEvent? arg_bodyPositionEvent =
              (args[0] as BodyPositionEvent?);
          assert(arg_bodyPositionEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveBodyPosition was null, expected non-null BodyPositionEvent.');
          try {
            api.didReceiveBodyPosition(arg_bodyPositionEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveActivity',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveActivity was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final ActivityEvent? arg_activityEvent = (args[0] as ActivityEvent?);
          assert(arg_activityEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveActivity was null, expected non-null ActivityEvent.');
          try {
            api.didReceiveActivity(arg_activityEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSteps',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSteps was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final StepsEvent? arg_stepsEvent = (args[0] as StepsEvent?);
          assert(arg_stepsEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSteps was null, expected non-null StepsEvent.');
          try {
            api.didReceiveSteps(arg_stepsEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveHeartRate',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveHeartRate was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final HeartRateEvent? arg_heartRateEvent =
              (args[0] as HeartRateEvent?);
          assert(arg_heartRateEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveHeartRate was null, expected non-null HeartRateEvent.');
          try {
            api.didReceiveHeartRate(arg_heartRateEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveRr',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveRr was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final RrEvent? arg_rrEvent = (args[0] as RrEvent?);
          assert(arg_rrEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveRr was null, expected non-null RrEvent.');
          try {
            api.didReceiveRr(arg_rrEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.wearStateDidChange',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.wearStateDidChange was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final WearStateEvent? arg_wearStateEvent =
              (args[0] as WearStateEvent?);
          assert(arg_wearStateEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.wearStateDidChange was null, expected non-null WearStateEvent.');
          try {
            api.wearStateDidChange(arg_wearStateEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didDetectExercise',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didDetectExercise was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final ExerciseEvent? arg_exerciseEvent = (args[0] as ExerciseEvent?);
          assert(arg_exerciseEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didDetectExercise was null, expected non-null ExerciseEvent.');
          try {
            api.didDetectExercise(arg_exerciseEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSoundVolume',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSoundVolume was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final SoundVolumeEvent? arg_soundVolumeEvent =
              (args[0] as SoundVolumeEvent?);
          assert(arg_soundVolumeEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSoundVolume was null, expected non-null SoundVolumeEvent.');
          try {
            api.didReceiveSoundVolume(arg_soundVolumeEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveCommand',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveCommand was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final EmptyEvent? arg_voidEvent = (args[0] as EmptyEvent?);
          assert(arg_voidEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveCommand was null, expected non-null EmptyEvent.');
          try {
            api.didReceiveCommand(arg_voidEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveError',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveError was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final ErrorEvent? arg_errorEvent = (args[0] as ErrorEvent?);
          assert(arg_errorEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveError was null, expected non-null ErrorEvent.');
          try {
            api.didReceiveError(arg_errorEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveMessage',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveMessage was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final MessageEvent? arg_messageEvent = (args[0] as MessageEvent?);
          assert(arg_messageEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveMessage was null, expected non-null MessageEvent.');
          try {
            api.didReceiveMessage(arg_messageEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didDetectUserEvent',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didDetectUserEvent was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final UserEvent? arg_userEvent = (args[0] as UserEvent?);
          assert(arg_userEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didDetectUserEvent was null, expected non-null UserEvent.');
          try {
            api.didDetectUserEvent(arg_userEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSoundFeatures',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSoundFeatures was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final SoundFeaturesEvent? arg_soundFeaturesEvent =
              (args[0] as SoundFeaturesEvent?);
          assert(arg_soundFeaturesEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSoundFeatures was null, expected non-null SoundFeaturesEvent.');
          try {
            api.didReceiveSoundFeatures(arg_soundFeaturesEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSignalQuality',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSignalQuality was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final SignalQualityEvent? arg_signalQualityEvent =
              (args[0] as SignalQualityEvent?);
          assert(arg_signalQualityEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabDelegate.didReceiveSignalQuality was null, expected non-null SignalQualityEvent.');
          try {
            api.didReceiveSignalQuality(arg_signalQualityEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
  }
}

class _PlatformAidlabInternalDelegateCodec extends StandardMessageCodec {
  const _PlatformAidlabInternalDelegateCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is FirmwareInformationEvent) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else if (value is PressureEvent) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else if (value is PressureWearStateEvent) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return FirmwareInformationEvent.decode(readValue(buffer)!);
      case 129:
        return PressureEvent.decode(readValue(buffer)!);
      case 130:
        return PressureWearStateEvent.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}

abstract class PlatformAidlabInternalDelegate {
  static const MessageCodec<Object?> pigeonChannelCodec =
      _PlatformAidlabInternalDelegateCodec();

  void didReceiveFirmwareInformation(
      FirmwareInformationEvent firmwareInformationEvent);

  void didReceivePressure(PressureEvent pressureEvent);

  void pressureWearStateDidChange(PressureWearStateEvent wearStateEvent);

  static void setup(PlatformAidlabInternalDelegate? api,
      {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabInternalDelegate.didReceiveFirmwareInformation',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabInternalDelegate.didReceiveFirmwareInformation was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final FirmwareInformationEvent? arg_firmwareInformationEvent =
              (args[0] as FirmwareInformationEvent?);
          assert(arg_firmwareInformationEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabInternalDelegate.didReceiveFirmwareInformation was null, expected non-null FirmwareInformationEvent.');
          try {
            api.didReceiveFirmwareInformation(arg_firmwareInformationEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabInternalDelegate.didReceivePressure',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabInternalDelegate.didReceivePressure was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PressureEvent? arg_pressureEvent = (args[0] as PressureEvent?);
          assert(arg_pressureEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabInternalDelegate.didReceivePressure was null, expected non-null PressureEvent.');
          try {
            api.didReceivePressure(arg_pressureEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabInternalDelegate.pressureWearStateDidChange',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabInternalDelegate.pressureWearStateDidChange was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PressureWearStateEvent? arg_wearStateEvent =
              (args[0] as PressureWearStateEvent?);
          assert(arg_wearStateEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabInternalDelegate.pressureWearStateDidChange was null, expected non-null PressureWearStateEvent.');
          try {
            api.pressureWearStateDidChange(arg_wearStateEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
  }
}

class _PlatformAidlabUpdateDelegateCodec extends StandardMessageCodec {
  const _PlatformAidlabUpdateDelegateCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is EmptyEvent) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else if (value is UpdateEvent) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else if (value is UpdateProgress) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return EmptyEvent.decode(readValue(buffer)!);
      case 129:
        return UpdateEvent.decode(readValue(buffer)!);
      case 130:
        return UpdateProgress.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}

abstract class PlatformAidlabUpdateDelegate {
  static const MessageCodec<Object?> pigeonChannelCodec =
      _PlatformAidlabUpdateDelegateCodec();

  void didFinishUpdate(EmptyEvent nothing);

  void didReceiveUpdateError(UpdateEvent event);

  void didReceiveUpdateProgress(UpdateProgress progress);

  static void setup(PlatformAidlabUpdateDelegate? api,
      {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabUpdateDelegate.didFinishUpdate',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabUpdateDelegate.didFinishUpdate was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final EmptyEvent? arg_nothing = (args[0] as EmptyEvent?);
          assert(arg_nothing != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabUpdateDelegate.didFinishUpdate was null, expected non-null EmptyEvent.');
          try {
            api.didFinishUpdate(arg_nothing!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabUpdateDelegate.didReceiveUpdateError',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabUpdateDelegate.didReceiveUpdateError was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final UpdateEvent? arg_event = (args[0] as UpdateEvent?);
          assert(arg_event != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabUpdateDelegate.didReceiveUpdateError was null, expected non-null UpdateEvent.');
          try {
            api.didReceiveUpdateError(arg_event!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabUpdateDelegate.didReceiveUpdateProgress',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabUpdateDelegate.didReceiveUpdateProgress was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final UpdateProgress? arg_progress = (args[0] as UpdateProgress?);
          assert(arg_progress != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabUpdateDelegate.didReceiveUpdateProgress was null, expected non-null UpdateProgress.');
          try {
            api.didReceiveUpdateProgress(arg_progress!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
  }
}

class _PlatformAidlabCodec extends StandardMessageCodec {
  const _PlatformAidlabCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is EcgFiltrationRequest) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else if (value is FirmwareInfoRequest) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else if (value is FirmwareUpdateRequest) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else if (value is SendRequest) {
      buffer.putUint8(131);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return EcgFiltrationRequest.decode(readValue(buffer)!);
      case 129:
        return FirmwareInfoRequest.decode(readValue(buffer)!);
      case 130:
        return FirmwareUpdateRequest.decode(readValue(buffer)!);
      case 131:
        return SendRequest.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}

class PlatformAidlab {
  /// Constructor for [PlatformAidlab].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  PlatformAidlab({BinaryMessenger? binaryMessenger})
      : __pigeon_binaryMessenger = binaryMessenger;
  final BinaryMessenger? __pigeon_binaryMessenger;

  static const MessageCodec<Object?> pigeonChannelCodec =
      _PlatformAidlabCodec();

  Future<void> disconnect() async {
    const String __pigeon_channelName =
        'dev.flutter.pigeon.aidlab_sdk.PlatformAidlab.disconnect';
    final BasicMessageChannel<Object?> __pigeon_channel =
        BasicMessageChannel<Object?>(
      __pigeon_channelName,
      pigeonChannelCodec,
      binaryMessenger: __pigeon_binaryMessenger,
    );
    final List<Object?>? __pigeon_replyList =
        await __pigeon_channel.send(null) as List<Object?>?;
    if (__pigeon_replyList == null) {
      throw _createConnectionError(__pigeon_channelName);
    } else if (__pigeon_replyList.length > 1) {
      throw PlatformException(
        code: __pigeon_replyList[0]! as String,
        message: __pigeon_replyList[1] as String?,
        details: __pigeon_replyList[2],
      );
    } else {
      return;
    }
  }

  Future<void> send(SendRequest sendRequest) async {
    const String __pigeon_channelName =
        'dev.flutter.pigeon.aidlab_sdk.PlatformAidlab.send';
    final BasicMessageChannel<Object?> __pigeon_channel =
        BasicMessageChannel<Object?>(
      __pigeon_channelName,
      pigeonChannelCodec,
      binaryMessenger: __pigeon_binaryMessenger,
    );
    final List<Object?>? __pigeon_replyList =
        await __pigeon_channel.send(<Object?>[sendRequest]) as List<Object?>?;
    if (__pigeon_replyList == null) {
      throw _createConnectionError(__pigeon_channelName);
    } else if (__pigeon_replyList.length > 1) {
      throw PlatformException(
        code: __pigeon_replyList[0]! as String,
        message: __pigeon_replyList[1] as String?,
        details: __pigeon_replyList[2],
      );
    } else {
      return;
    }
  }

  Future<void> setECGFiltrationMethod(
      EcgFiltrationRequest ecgFiltrationRequest) async {
    const String __pigeon_channelName =
        'dev.flutter.pigeon.aidlab_sdk.PlatformAidlab.setECGFiltrationMethod';
    final BasicMessageChannel<Object?> __pigeon_channel =
        BasicMessageChannel<Object?>(
      __pigeon_channelName,
      pigeonChannelCodec,
      binaryMessenger: __pigeon_binaryMessenger,
    );
    final List<Object?>? __pigeon_replyList = await __pigeon_channel
        .send(<Object?>[ecgFiltrationRequest]) as List<Object?>?;
    if (__pigeon_replyList == null) {
      throw _createConnectionError(__pigeon_channelName);
    } else if (__pigeon_replyList.length > 1) {
      throw PlatformException(
        code: __pigeon_replyList[0]! as String,
        message: __pigeon_replyList[1] as String?,
        details: __pigeon_replyList[2],
      );
    } else {
      return;
    }
  }

  Future<void> startSynchronization() async {
    const String __pigeon_channelName =
        'dev.flutter.pigeon.aidlab_sdk.PlatformAidlab.startSynchronization';
    final BasicMessageChannel<Object?> __pigeon_channel =
        BasicMessageChannel<Object?>(
      __pigeon_channelName,
      pigeonChannelCodec,
      binaryMessenger: __pigeon_binaryMessenger,
    );
    final List<Object?>? __pigeon_replyList =
        await __pigeon_channel.send(null) as List<Object?>?;
    if (__pigeon_replyList == null) {
      throw _createConnectionError(__pigeon_channelName);
    } else if (__pigeon_replyList.length > 1) {
      throw PlatformException(
        code: __pigeon_replyList[0]! as String,
        message: __pigeon_replyList[1] as String?,
        details: __pigeon_replyList[2],
      );
    } else {
      return;
    }
  }

  Future<void> stopSynchronization() async {
    const String __pigeon_channelName =
        'dev.flutter.pigeon.aidlab_sdk.PlatformAidlab.stopSynchronization';
    final BasicMessageChannel<Object?> __pigeon_channel =
        BasicMessageChannel<Object?>(
      __pigeon_channelName,
      pigeonChannelCodec,
      binaryMessenger: __pigeon_binaryMessenger,
    );
    final List<Object?>? __pigeon_replyList =
        await __pigeon_channel.send(null) as List<Object?>?;
    if (__pigeon_replyList == null) {
      throw _createConnectionError(__pigeon_channelName);
    } else if (__pigeon_replyList.length > 1) {
      throw PlatformException(
        code: __pigeon_replyList[0]! as String,
        message: __pigeon_replyList[1] as String?,
        details: __pigeon_replyList[2],
      );
    } else {
      return;
    }
  }

  Future<void> requestForFirmwareInfo(
      FirmwareInfoRequest firmwareInfoRequest) async {
    const String __pigeon_channelName =
        'dev.flutter.pigeon.aidlab_sdk.PlatformAidlab.requestForFirmwareInfo';
    final BasicMessageChannel<Object?> __pigeon_channel =
        BasicMessageChannel<Object?>(
      __pigeon_channelName,
      pigeonChannelCodec,
      binaryMessenger: __pigeon_binaryMessenger,
    );
    final List<Object?>? __pigeon_replyList = await __pigeon_channel
        .send(<Object?>[firmwareInfoRequest]) as List<Object?>?;
    if (__pigeon_replyList == null) {
      throw _createConnectionError(__pigeon_channelName);
    } else if (__pigeon_replyList.length > 1) {
      throw PlatformException(
        code: __pigeon_replyList[0]! as String,
        message: __pigeon_replyList[1] as String?,
        details: __pigeon_replyList[2],
      );
    } else {
      return;
    }
  }

  Future<void> startFirmwareUpdate(
      FirmwareUpdateRequest firmwareUpdateRequest) async {
    const String __pigeon_channelName =
        'dev.flutter.pigeon.aidlab_sdk.PlatformAidlab.startFirmwareUpdate';
    final BasicMessageChannel<Object?> __pigeon_channel =
        BasicMessageChannel<Object?>(
      __pigeon_channelName,
      pigeonChannelCodec,
      binaryMessenger: __pigeon_binaryMessenger,
    );
    final List<Object?>? __pigeon_replyList = await __pigeon_channel
        .send(<Object?>[firmwareUpdateRequest]) as List<Object?>?;
    if (__pigeon_replyList == null) {
      throw _createConnectionError(__pigeon_channelName);
    } else if (__pigeon_replyList.length > 1) {
      throw PlatformException(
        code: __pigeon_replyList[0]! as String,
        message: __pigeon_replyList[1] as String?,
        details: __pigeon_replyList[2],
      );
    } else {
      return;
    }
  }
}

class _PlatformAidlabSynchronizationDelegateCodec extends StandardMessageCodec {
  const _PlatformAidlabSynchronizationDelegateCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is ActivityEvent) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else if (value is BodyPositionEvent) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else if (value is EcgEvent) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else if (value is HeartRateEvent) {
      buffer.putUint8(131);
      writeValue(buffer, value.encode());
    } else if (value is OrientationEvent) {
      buffer.putUint8(132);
      writeValue(buffer, value.encode());
    } else if (value is PressureEvent) {
      buffer.putUint8(133);
      writeValue(buffer, value.encode());
    } else if (value is QuaternionEvent) {
      buffer.putUint8(134);
      writeValue(buffer, value.encode());
    } else if (value is RespirationEvent) {
      buffer.putUint8(135);
      writeValue(buffer, value.encode());
    } else if (value is RespirationRateEvent) {
      buffer.putUint8(136);
      writeValue(buffer, value.encode());
    } else if (value is RrEvent) {
      buffer.putUint8(137);
      writeValue(buffer, value.encode());
    } else if (value is SignalQualityEvent) {
      buffer.putUint8(138);
      writeValue(buffer, value.encode());
    } else if (value is SkinTemperatureEvent) {
      buffer.putUint8(139);
      writeValue(buffer, value.encode());
    } else if (value is SoundFeaturesEvent) {
      buffer.putUint8(140);
      writeValue(buffer, value.encode());
    } else if (value is SoundVolumeEvent) {
      buffer.putUint8(141);
      writeValue(buffer, value.encode());
    } else if (value is StepsEvent) {
      buffer.putUint8(142);
      writeValue(buffer, value.encode());
    } else if (value is SyncStateEvent) {
      buffer.putUint8(143);
      writeValue(buffer, value.encode());
    } else if (value is UnsynchronizedSizeEvent) {
      buffer.putUint8(144);
      writeValue(buffer, value.encode());
    } else if (value is UserEvent) {
      buffer.putUint8(145);
      writeValue(buffer, value.encode());
    } else if (value is VectorEvent) {
      buffer.putUint8(146);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return ActivityEvent.decode(readValue(buffer)!);
      case 129:
        return BodyPositionEvent.decode(readValue(buffer)!);
      case 130:
        return EcgEvent.decode(readValue(buffer)!);
      case 131:
        return HeartRateEvent.decode(readValue(buffer)!);
      case 132:
        return OrientationEvent.decode(readValue(buffer)!);
      case 133:
        return PressureEvent.decode(readValue(buffer)!);
      case 134:
        return QuaternionEvent.decode(readValue(buffer)!);
      case 135:
        return RespirationEvent.decode(readValue(buffer)!);
      case 136:
        return RespirationRateEvent.decode(readValue(buffer)!);
      case 137:
        return RrEvent.decode(readValue(buffer)!);
      case 138:
        return SignalQualityEvent.decode(readValue(buffer)!);
      case 139:
        return SkinTemperatureEvent.decode(readValue(buffer)!);
      case 140:
        return SoundFeaturesEvent.decode(readValue(buffer)!);
      case 141:
        return SoundVolumeEvent.decode(readValue(buffer)!);
      case 142:
        return StepsEvent.decode(readValue(buffer)!);
      case 143:
        return SyncStateEvent.decode(readValue(buffer)!);
      case 144:
        return UnsynchronizedSizeEvent.decode(readValue(buffer)!);
      case 145:
        return UserEvent.decode(readValue(buffer)!);
      case 146:
        return VectorEvent.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}

abstract class PlatformAidlabSynchronizationDelegate {
  static const MessageCodec<Object?> pigeonChannelCodec =
      _PlatformAidlabSynchronizationDelegateCodec();

  void syncStateDidChange(SyncStateEvent syncStateEvent);

  void didReceivePastECG(EcgEvent ecgEvent);

  void didReceivePastRespiration(RespirationEvent respirationEvent);

  void didReceivePastSkinTemperature(SkinTemperatureEvent skinTemperatureEvent);

  void didReceivePastHeartRate(HeartRateEvent heartRateEvent);

  void didReceivePastRr(RrEvent rrEvent);

  void didReceiveUnsynchronizedSize(
      UnsynchronizedSizeEvent unsynchronizedSizeEvent);

  void didReceivePastRespirationRate(RespirationRateEvent respirationRateEvent);

  void didReceivePastActivity(ActivityEvent activityEvent);

  void didReceivePastSteps(StepsEvent stepsEvent);

  void didReceivePastSoundVolume(SoundVolumeEvent soundVolumeEvent);

  void didReceivePastAccelerometer(VectorEvent vectorEvent);

  void didReceivePastGyroscope(VectorEvent vectorEvent);

  void didReceivePastMagnetometer(VectorEvent vectorEvent);

  void didReceivePastQuaternion(QuaternionEvent quaternionEvent);

  void didReceivePastOrientation(OrientationEvent orientationEvent);

  void didReceivePastBodyPosition(BodyPositionEvent bodyPositionEvent);

  void didReceivePastPressure(PressureEvent pressureEvent);

  void didDetectPastUserEvent(UserEvent userEvent);

  void didReceivePastSoundFeatures(SoundFeaturesEvent soundFeaturesEvent);

  void didReceivePastSignalQuality(SignalQualityEvent signalQualityEvent);

  static void setup(PlatformAidlabSynchronizationDelegate? api,
      {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.syncStateDidChange',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.syncStateDidChange was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final SyncStateEvent? arg_syncStateEvent =
              (args[0] as SyncStateEvent?);
          assert(arg_syncStateEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.syncStateDidChange was null, expected non-null SyncStateEvent.');
          try {
            api.syncStateDidChange(arg_syncStateEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastECG',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastECG was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final EcgEvent? arg_ecgEvent = (args[0] as EcgEvent?);
          assert(arg_ecgEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastECG was null, expected non-null EcgEvent.');
          try {
            api.didReceivePastECG(arg_ecgEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastRespiration',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastRespiration was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final RespirationEvent? arg_respirationEvent =
              (args[0] as RespirationEvent?);
          assert(arg_respirationEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastRespiration was null, expected non-null RespirationEvent.');
          try {
            api.didReceivePastRespiration(arg_respirationEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSkinTemperature',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSkinTemperature was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final SkinTemperatureEvent? arg_skinTemperatureEvent =
              (args[0] as SkinTemperatureEvent?);
          assert(arg_skinTemperatureEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSkinTemperature was null, expected non-null SkinTemperatureEvent.');
          try {
            api.didReceivePastSkinTemperature(arg_skinTemperatureEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastHeartRate',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastHeartRate was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final HeartRateEvent? arg_heartRateEvent =
              (args[0] as HeartRateEvent?);
          assert(arg_heartRateEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastHeartRate was null, expected non-null HeartRateEvent.');
          try {
            api.didReceivePastHeartRate(arg_heartRateEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastRr',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastRr was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final RrEvent? arg_rrEvent = (args[0] as RrEvent?);
          assert(arg_rrEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastRr was null, expected non-null RrEvent.');
          try {
            api.didReceivePastRr(arg_rrEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceiveUnsynchronizedSize',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceiveUnsynchronizedSize was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final UnsynchronizedSizeEvent? arg_unsynchronizedSizeEvent =
              (args[0] as UnsynchronizedSizeEvent?);
          assert(arg_unsynchronizedSizeEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceiveUnsynchronizedSize was null, expected non-null UnsynchronizedSizeEvent.');
          try {
            api.didReceiveUnsynchronizedSize(arg_unsynchronizedSizeEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastRespirationRate',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastRespirationRate was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final RespirationRateEvent? arg_respirationRateEvent =
              (args[0] as RespirationRateEvent?);
          assert(arg_respirationRateEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastRespirationRate was null, expected non-null RespirationRateEvent.');
          try {
            api.didReceivePastRespirationRate(arg_respirationRateEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastActivity',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastActivity was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final ActivityEvent? arg_activityEvent = (args[0] as ActivityEvent?);
          assert(arg_activityEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastActivity was null, expected non-null ActivityEvent.');
          try {
            api.didReceivePastActivity(arg_activityEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSteps',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSteps was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final StepsEvent? arg_stepsEvent = (args[0] as StepsEvent?);
          assert(arg_stepsEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSteps was null, expected non-null StepsEvent.');
          try {
            api.didReceivePastSteps(arg_stepsEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSoundVolume',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSoundVolume was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final SoundVolumeEvent? arg_soundVolumeEvent =
              (args[0] as SoundVolumeEvent?);
          assert(arg_soundVolumeEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSoundVolume was null, expected non-null SoundVolumeEvent.');
          try {
            api.didReceivePastSoundVolume(arg_soundVolumeEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastAccelerometer',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastAccelerometer was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final VectorEvent? arg_vectorEvent = (args[0] as VectorEvent?);
          assert(arg_vectorEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastAccelerometer was null, expected non-null VectorEvent.');
          try {
            api.didReceivePastAccelerometer(arg_vectorEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastGyroscope',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastGyroscope was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final VectorEvent? arg_vectorEvent = (args[0] as VectorEvent?);
          assert(arg_vectorEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastGyroscope was null, expected non-null VectorEvent.');
          try {
            api.didReceivePastGyroscope(arg_vectorEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastMagnetometer',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastMagnetometer was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final VectorEvent? arg_vectorEvent = (args[0] as VectorEvent?);
          assert(arg_vectorEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastMagnetometer was null, expected non-null VectorEvent.');
          try {
            api.didReceivePastMagnetometer(arg_vectorEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastQuaternion',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastQuaternion was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final QuaternionEvent? arg_quaternionEvent =
              (args[0] as QuaternionEvent?);
          assert(arg_quaternionEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastQuaternion was null, expected non-null QuaternionEvent.');
          try {
            api.didReceivePastQuaternion(arg_quaternionEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastOrientation',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastOrientation was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final OrientationEvent? arg_orientationEvent =
              (args[0] as OrientationEvent?);
          assert(arg_orientationEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastOrientation was null, expected non-null OrientationEvent.');
          try {
            api.didReceivePastOrientation(arg_orientationEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastBodyPosition',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastBodyPosition was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final BodyPositionEvent? arg_bodyPositionEvent =
              (args[0] as BodyPositionEvent?);
          assert(arg_bodyPositionEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastBodyPosition was null, expected non-null BodyPositionEvent.');
          try {
            api.didReceivePastBodyPosition(arg_bodyPositionEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastPressure',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastPressure was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final PressureEvent? arg_pressureEvent = (args[0] as PressureEvent?);
          assert(arg_pressureEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastPressure was null, expected non-null PressureEvent.');
          try {
            api.didReceivePastPressure(arg_pressureEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didDetectPastUserEvent',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didDetectPastUserEvent was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final UserEvent? arg_userEvent = (args[0] as UserEvent?);
          assert(arg_userEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didDetectPastUserEvent was null, expected non-null UserEvent.');
          try {
            api.didDetectPastUserEvent(arg_userEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSoundFeatures',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSoundFeatures was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final SoundFeaturesEvent? arg_soundFeaturesEvent =
              (args[0] as SoundFeaturesEvent?);
          assert(arg_soundFeaturesEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSoundFeatures was null, expected non-null SoundFeaturesEvent.');
          try {
            api.didReceivePastSoundFeatures(arg_soundFeaturesEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSignalQuality',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSignalQuality was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final SignalQualityEvent? arg_signalQualityEvent =
              (args[0] as SignalQualityEvent?);
          assert(arg_signalQualityEvent != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.PlatformAidlabSynchronizationDelegate.didReceivePastSignalQuality was null, expected non-null SignalQualityEvent.');
          try {
            api.didReceivePastSignalQuality(arg_signalQualityEvent!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
  }
}
